/* $Id: ColumnPrim.java,v 1.1.1.1 2001/03/20 02:42:10 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.align;

import	java.io.IOException;
import	java.io.ObjectInputStream;
import	nts.command.Command;
import	nts.command.Token;
import	nts.command.Prim;
import	nts.command.LeftBraceToken;
import	nts.command.RightBraceToken;

public class	ColumnPrim	extends Prim {

    private final Alignment.ColumnEnding	ending;

    ColumnPrim(String name, Alignment.ColumnEnding ending)
	{ super(name); this.ending = ending; }

    /* TeXtp[342] */
    public final boolean	explosive()
	{ return Alignment.columnBodyIsActiveAndBalanced(); }

    /* TeXtp[342] */
    public void		detonate(Token src)
	{ Alignment.finishActiveColumnBody(ending); }

    /* TeXtp[1127,1128] */
    public void		exec(Token src) {
	int	disbalance = Alignment.activeColumnDisbalance();
	if (Math.abs(disbalance) > 2)
	    error( (src.match(TabMarkToken.TOKEN))
	         ? "MisplacedTabMark" : "MisplacedCrSpan", meaningOf(src));
	else {
	    backToken(src);
	    if (disbalance < 0) {
		insertToken(LeftBraceToken.TOKEN);
		error("AllignLeftError");
	    } else {
		insertToken(RightBraceToken.TOKEN);
		error("AllignRightError");
	    }
	}
    }

}
