/* $Id: DispAlignGroup.java,v 1.1.1.1 2001/03/22 13:47:54 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.align;

import	nts.base.Num;
import	nts.base.Dimen;
import	nts.node.NodeEnum;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.math.DisplayGroup;

public class	DispAlignGroup	extends AlignGroup {

    public DispAlignGroup(Alignment align) { super(align); }

    public static final int	INTP_PRE_DISPLAY_PENALTY
		=  DisplayGroup.INTP_PRE_DISPLAY_PENALTY;
    public static final int	INTP_POST_DISPLAY_PENALTY
		=  DisplayGroup.INTP_POST_DISPLAY_PENALTY;
    public static final int	DIMP_DISPLAY_INDENT
		=  DisplayGroup.DIMP_DISPLAY_INDENT;
    public static final int	GLUEP_ABOVE_DISPLAY_SKIP
		=  DisplayGroup.GLUEP_ABOVE_DISPLAY_SKIP;
    public static final int	GLUEP_BELOW_DISPLAY_SKIP
		=  DisplayGroup.GLUEP_BELOW_DISPLAY_SKIP;

    /* TeXtp[812,1206] */
    public void		stop() { 
	Config		cfg = getConfig();
	Dimen		indent = cfg.getDimParam(DIMP_DISPLAY_INDENT);
	NodeEnum	nodes = align.finish(indent);
	if (expectMathShift())
	    DisplayGroup.expectAnotherMathShift();
	Builder.pop();
	Builder		bld = Builder.top();
	bld.addPenalty(Num.valueOf(
			cfg.getIntParam(INTP_PRE_DISPLAY_PENALTY)));
	bld.addSkip(cfg.getGlueParam(GLUEP_ABOVE_DISPLAY_SKIP),
		    cfg.getGlueName(GLUEP_ABOVE_DISPLAY_SKIP));
	bld.addNodes(nodes);
	bld.addPenalty(Num.valueOf(
			cfg.getIntParam(INTP_POST_DISPLAY_PENALTY)));
	bld.addSkip(cfg.getGlueParam(GLUEP_BELOW_DISPLAY_SKIP),
		    cfg.getGlueName(GLUEP_BELOW_DISPLAY_SKIP));
	align.copyPrevParameters(bld);
    }

    public void		close()
	{ killLevel(); DisplayGroup.resumeAfterDisplay(); }

    /* TeXtp[1207] */
    protected static boolean	expectMathShift() {
	Token	tok = nextNonAssignment();
	if (!meaningOf(tok).isMathShift())
	    { backToken(tok); error("MissingFormulaEnd"); return false; }
	return true;
    }

}
