/* $Id: EndTemplate.java,v 1.1.1.1 2001/04/04 23:03:16 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.align;

import	nts.io.Log;
import	nts.command.Token;
import	nts.command.Expandable;

public class	EndTemplate	extends Expandable {

    private final Token		body;

    public EndTemplate(Token body) { this.body = body; }

    /* STRANGE
     * backing up the body token is the method used in expand procedure in TeX.
     * However in get_x_token it is bypassed and the body is returned straight
     * away without backing up. That makes differences when showing context.
     * Keeping compatibility with TeX would require boolean parameter to
     * nextExpToken and another method to Command interface which is clearly
     * too expensive for such a rare case.
     * The sentence: "The |get_x_token| procedure is equivalent to two
     * consecutive procedure calls: |get_next; x_token|." in TeXtp[381]
     * is therefore not valid.
     */
    /* TeXtp[375,380] */
    public void		doExpansion(Token src) { backToken(body); }

    public boolean	isOuter() { return true; }

    /* TeXtp[296,1295] */
    public void		addExpandable(Log log, boolean full) {
        log.addEsc("outer").add(" endtemplate");
	if (full) { log.add(':').endLine(); }
    }

}
