/* $Id: VAlignPrim.java,v 1.1.1.1 2001/03/21 08:18:23 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.align;

import	nts.base.Dimen;
import	nts.builder.Builder;
import	nts.builder.ListBuilder;
import	nts.builder.HBoxBuilder;
import	nts.command.Command;
import	nts.command.Primitive;
import	nts.command.Token;
import	nts.command.TokenList;

public class	VAlignPrim	extends AlignPrim {

    public VAlignPrim(String name, TokenList.Inserter everyCr,
		     Primitive carRet, Command endv)
	{ super(name, everyCr, carRet, endv); }

    protected ListBuilder	makeOuterBuilder(int lineNo) {
	ListBuilder	builder = new HBoxBuilder(lineNo);
	builder.setSpaceFactor(Builder.top().nearestValidSpaceFactor());
	return builder;
    }

    protected Alignment		makeAlignment(Dimen size, boolean exactly,
					      TokenList.Inserter everyCr,
					      Token frzCr, Token frzEndt,
					      ListBuilder builder) {
	return new VertAlignment(size, exactly, everyCr,
				 frzCr, frzEndt, builder);
    }

}
