/* $Id: IntPar.java,v 1.1.1.1 2001/05/17 23:28:27 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.base;

/** Output parameter class for the |int| type.
 * Used as a medium for (optional) returning values of type
 * |integer| when more return values are needed.
 *
 * @author	Karel Skoupy
 * @version	${VERSION}
 * @since	NTS1.0
 */
public class	IntPar {

    /** Null constant for value of the |IntPar| */
    public static final IntPar		NULL = null;

    /** value of the parameter */
    private int		value;

    /** default constructor (default value of parameter (0)) */
    public IntPar() { }

    /** Constructor for initial value of the parameter
     * @param	val	initial value of the parameter
     */
    public IntPar(int val) { value = val; }

    /** Sets a new value of the parameter
     * @param	val	new value of the parameter
     */
    public void		set(int val) { value = val; }

    /** Gets the value of the parameter
     * @return	value of the parameter
     */
    public int		get() { return value; }

    /** Sets the value of the |IntPar| if the |IntPar| is given
     * (non-|null|)
     * @param	par	instance of |IntPar| parameter or |null|
     * @param	val	new value of the parameter
     */
    public static void	set(IntPar par, int val)
	{ if (par != NULL) par.value = val; }

}
