/* $Id: NullBuilder.java,v 1.1.1.1 2001/03/20 11:21:34 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.builder;

import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.node.Node;
import	nts.node.NodeEnum;
import	nts.node.BoxSizes;
import	nts.node.Leaders;

public class	NullBuilder	extends Builder	{

    public void		addNode(Node node) { }
    public void		addNodes(NodeEnum nodes) { }
    public void		addKern(Dimen kern) { }
    public void		addSkip(Glue skip) { }
    public void		addNamedSkip(Glue skip, String name) { }
    public void		addRule(BoxSizes sizes) { }
    public void		addLeaders(Glue skip, Leaders lead) { }
    public void		addLeadRule(Glue skip, BoxSizes sizes,
				    String desc) { }
    public boolean	isEmpty() { return true; }
    public Node		lastNode() { return Node.NULL; }
    public void		removeLastNode() { }
    public Node		lastSpecialNode() { return Node.NULL; }
    public int		getPrevGraf() { return 0; }
    public void		setPrevGraf(int pg) { }
    public String	modeName() { return "no"; }

}
