/* $Id: PageBuilder.java,v 1.1.1.1 2001/03/20 11:21:42 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.builder;

import	nts.io.Log;
import	nts.base.Num;
import	nts.node.PageSplit;

public class	PageBuilder extends VertBuilder {

    public PageBuilder(int line, PageSplit list) { super(line, list); }
    protected final PageSplit	pageSplit() { return (PageSplit) list; }
    public String	modeName() { return "vertical"; }
    public boolean	willBeBroken() { return true; }
    public void		buildPage() { pageSplit().build(); }

    public boolean	needsParSkip() { return true; }
    //XXX maybe the par_skip on the top of the page is ignored anyhow, so we
    //XXX can introduce NodeList predicat like didntStartYet and use it
    //XXX instead of isEmpty.

    public boolean	canTakeLastNode()
	{ return (!pageSplit().allConsumed()); }

    protected void	specialShow(Log log, int depth, int breadth)
	{ pageSplit().show(log, depth, breadth); specialShow(log); }

}
