/* $Id: ParBuilder.java,v 1.1.1.1 2001/03/20 11:21:47 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.builder;

import	nts.io.Log;
import	nts.node.NodeList;
import	nts.node.Language;
import	nts.node.LanguageNode;

public class	ParBuilder extends HorizBuilder {

    private final Language	initLang;
    private Language		currLang;

    public ParBuilder(int line, Language initLang)
	{ super(line); this.initLang = initLang; currLang = initLang; }

    public String	modeName() { return "horizontal"; }
    public boolean	willBeBroken() { return true; }
    public NodeList	getParagraph() { return list; }

    public Language	getInitLang() { return initLang; }
    public Language	getCurrLang() { return currLang; }

    public void		setCurrLang(Language lang)
	{ currLang = lang; addNode(new LanguageNode(lang)); }

    /* TeXtp[218] */
    protected void	specialShow(Log log, int depth, int breadth) {
        if (!initLang.isCommon())
	    log.add(" (").add(initLang).add(')');
	super.specialShow(log, depth, breadth);
    }

    /* TeXtp[219] */
    protected void	specialShow(Log log) {
	super.specialShow(log);
	if (!currLang.isZero())
	    { log.add(", current language "); currLang.addNumberOn(log); }
    }

}
