/* $Id: AnyDimenParam.java,v 1.1.1.1 1999/06/08 22:03:01 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Dimen;
import	nts.io.Log;

/**
 */
public abstract class	AnyDimenParam extends PerformableParam {

    private Dimen		value;

    /**
     * Creates a new AnyDimenParam with given name and value and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the AnyDimenParam
     * @param	val the value of the AnyDimenParam
     */
    public AnyDimenParam(String name, Dimen val)
	{ super(name); value = val; }

    /**
     * Creates a new AnyDimenParam with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the AnyDimenParam
     */
    public AnyDimenParam(String name) { this(name, Dimen.ZERO); }

    public final Object	getEqValue() { return value; }

    public final void	setEqValue(Object val) { value = (Dimen) val; }

    public final void	addEqValueOn(Log log)
	{ log.add(value.toString(getUnit())); }

    public abstract String	getUnit();

    public final Dimen	get() { return value; }

    public void		set(Dimen val, boolean glob)
	{ beforeSetting(glob); value = val; }

}
