/* $Id: AnyMarkPrim.java,v 1.1.1.1 2000/01/31 21:42:34 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	java.io.ObjectInputStream;
import	java.io.IOException;
import	nts.io.Log;

public class	AnyMarkPrim	extends ExpandablePrim
				implements TokenList.Maintainer {

    private transient TokenList		value;

    protected AnyMarkPrim(String name, TokenList val)
	{ super(name); value = val; }

    public AnyMarkPrim(String name) { this(name, TokenList.EMPTY); }

    private void	readObject(ObjectInputStream input)
			    throws IOException, ClassNotFoundException
	{ input.defaultReadObject(); value = TokenList.EMPTY; }

    public TokenList	getToksValue() { return value; }
    public void		setToksValue(TokenList val) { value = val; }
    public boolean	isEmpty() { return value.isEmpty(); }

    public void		expand(Token src)
	{ tracedPushList(value, "mark"); }

    /* TeXtp[296] */
    public void		addExpandable(Log log, boolean full) {
        super.addExpandable(log, full);
	if (full) log.add(':').endLine().add(value);
    }

    /* TeXtp[223] */
    public void		addExpandable(Log log, int maxCount)
	{ addExpandable(log, false); }

}
