/* $Id: DimenDefPrim.java,v 1.1.1.1 1999/06/24 10:53:18 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Dimen;

public class	DimenDefPrim	extends ShorthandDefPrim {

    private DimenPrim		reg;

    public DimenDefPrim(String name, DimenPrim reg)
	{ super(name); this.reg = reg; }

    protected final Command	makeShorthand(int idx)
	{ return new Shorthand(idx); }

    public class	Shorthand	extends ShorthandDefPrim.Shorthand
    					implements Dimen.Provider {

	public Shorthand(int idx) { super(idx); }

	protected RegisterPrim		getReg() { return reg; }

	/**
	 * Performs the assignment.
	 * @param	src source token for diagnostic output.
	 * @param	glob indication that the assignment is global.
	 */
	protected final void	assign(Token src, boolean glob) {
	    skipOptEquals();
	    reg.set(index, scanDimen(), glob);
	}

	public final void	perform(int operation, boolean glob,
					Command after)
	    { reg.perform(index, operation, glob); }

	public boolean	hasDimenValue() { return true; }
	public Dimen	getDimenValue() { return reg.get(index); }

    }

}
