/* $Id: DimenPrim.java,v 1.1.1.1 1999/06/24 10:44:01 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Dimen;
import	nts.io.Log;

/**
 * Setting dimension register primitive.
 */
public class	DimenPrim	extends RegisterPrim
				implements Dimen.Provider {

    /**
     * Creates a new |DimenPrim| with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the |DimenPrim|
     */
    public DimenPrim(String name) { super(name); }

    public final void	set(int idx, Dimen val, boolean glob) {
	if (glob) getEqt().gput(tabKind, idx, val);
	else getEqt().put(tabKind, idx, val);
    }

    public final Dimen	get(int idx) {
        Dimen	val = (Dimen) getEqt().get(tabKind, idx);
	return (val != Dimen.NULL) ? val : Dimen.ZERO;
    }

    public void		addEqValueOn(int idx, Log log)
	{ log.add(get(idx).toString("pt")); }

    public void		perform(int idx, int operation, boolean glob)
	{ set(idx, performFor(get(idx), operation), glob); }

    /**
     * Performs the assignment.
     * @param	src source token for diagnostic output.
     * @param	glob indication that the assignment is global.
     */
    protected final void	assign(Token src, boolean glob) {
	int	idx = scanRegisterCode();
        skipOptEquals();
	set(idx, scanDimen(), glob);
    }

    public final void	perform(int operation, boolean glob, Command after)
	{ perform(scanRegisterCode(), operation, glob); }

    public boolean	hasDimenValue() { return true; }
    public Dimen	getDimenValue() { return get(scanRegisterCode()); }

}
