/* $Id: Expandable.java,v 1.1.1.1 2000/03/17 13:56:25 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	java.io.ObjectInputStream;
import	java.io.ObjectOutputStream;
import	java.io.IOException;
import	nts.io.Log;
import	nts.io.Loggable;

public abstract class Expandable	extends Relax {

    public static final int	BOOLP_TRACING_ALL_COMMANDS = newBoolParam();

    public final boolean	expandable() { return true; }

    public abstract void	doExpansion(Token src);

    public abstract void	addExpandable(Log log, boolean full);

    private static Relax	unExpanded;

    public static Relax		getUnExpanded() { return unExpanded; }

    public final Command	meaning(boolean expOK)
	{ return (expOK) ? this : unExpanded; }

    public static void		makeStaticData()
	{ unExpanded = new Relax(); }

    public static void		writeStaticData(ObjectOutputStream output)
    					throws IOException
	{ output.writeObject(unExpanded); }

    public static void		readStaticData(ObjectInputStream input)
				    throws IOException, ClassNotFoundException
	{ unExpanded = (Relax) input.readObject(); }

    protected static Loggable	exp(final Expandable e) {
        return new Loggable() {
	    public void		addOn(Log log) { e.addExpandable(log, false); }
	};
    }

}
