/* $Id: ExpandablePrim.java,v 1.1.1.1 2000/03/17 14:41:27 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.io.Log;

public abstract class	ExpandablePrim	extends Expandable
					implements Primitive {

    /** The name of the primitive */
    private String		name;

    /**
     * Creates a new Prim with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the Prim
     */
    protected	ExpandablePrim(String name) { this.name = name; }

    public final String		getName() { return name; }

    public final Command	getCommand() { return this; }

    public final String		toString() { return "@" + name; }

    /* TeXtp[367] */
    public final void		doExpansion(Token src) {
	if (getConfig().getBoolParam(BOOLP_TRACING_ALL_COMMANDS))
	    traceExpandable(this);
	expand(src);
    }

    public abstract void	expand(Token src);

    public void			addExpandable(Log log, boolean full)
	{ log.addEsc(name); }

    /* TeXtp[379] */
    protected static void	insertRelax()
	{ insertToken(new FrozenToken("relax", Relax.getRelax())); }

}
