/* $Id: GlueParam.java,v 1.1.1.1 2000/06/27 10:37:35 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Glue;

/**
 * Setting glue parameter primitive.
 */
public class	GlueParam	extends AnyGlueParam
				implements Glue.Provider {

    /**
     * Creates a new GlueParam with given name and value and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the GlueParam
     * @param	val the value of the GlueParam
     */
    public GlueParam(String name, Glue val) { super(name, val); }

    /**
     * Creates a new GlueParam with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the GlueParam
     */
    public GlueParam(String name) { super(name); }

    protected void	scanValue(Token src, boolean glob) {
    	set(scanGlue(), glob);
	// System.err.println("= Assignment \\" + getName() + " = " + get());
    }

    protected void	perform(int operation, boolean glob)
	{ set(performFor(get(), operation, false), glob); }

    public String	getUnit() { return "pt"; }
    public boolean	hasGlueValue() { return true; }
    public Glue		getGlueValue() { return get(); }

}
