/* $Id: GroupCommand.java,v 1.1.1.1 2000/04/16 10:26:00 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.ClassAssoc;

public abstract class	GroupCommand	extends Command {

    private static ClassAssoc	assoc = new ClassAssoc(Group.class);

    public static void		registerGroup(Class grp)
	{ assoc.record(grp); }

    public final GroupCommand	defineClosing(Class grp, Closing clos)
	{ assoc.put(grp, this, clos); return this; }

    public final Closing	getClosing(Class grp)
	{ return (Closing) assoc.get(grp, this); }

    public final void		exec(Token src) {
        Group		grp = getGrp();
        Closing		clos = getClosing(grp.getClass());
	if (clos == Closing.NULL) exec(grp, src);
	else clos.exec(grp, src);
    }

    public abstract void	exec(Group grp, Token src);

}
