/* $Id: InteractionPrim.java,v 1.1.1.1 2001/02/28 19:52:43 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

public class	InteractionPrim extends AssignPrim {

    public static final int		BATCH = 0;
    public static final int		NONSTOP = 1;
    public static final int		SCROLL = 2;
    public static final int		ERROR_STOP = 3;

    public static final String[]	names =
    	{ "batchmode", "nonstopmode", "scrollmode", "errorstopmode" };

    private static int		value = ERROR_STOP;

    public static int		get() { return value; }

    public static boolean	isSilent() { return (value == BATCH); }
    public static boolean	isInteractive() { return (value > NONSTOP); }
    public static boolean	isErrStopping() { return (value == ERROR_STOP); }

    public static void		setScroll()
	{ if (value > SCROLL) value = SCROLL; }

    public static void		set(int val)
	{ value = val; setTermEnable(value != BATCH); }

    public static void		set(String mnem) {
	for (int i = 0; i < names.length; i++)
	    if (mnem.equals(names[i])) { set(i); return; }
	throw new RuntimeException("Invalid interaction: " + mnem);
    }

    static {	//XXX move the property dependency to nts.tex.TeX
        String	prop = System.getProperty("nts.interaction");
	if (prop != null) set(prop); else set(ERROR_STOP);
	//XXX works only as INITEX (without loading a format)
    }

    private int			mode;

    public InteractionPrim(String name, int mode)
	{ super(name); this.mode = mode; }

    protected void	assign(Token src, boolean glob)
	{ normLog.endLine(); set(mode); }

}
