/* $Id: LetPrim.java,v 1.1.1.1 2000/03/17 14:43:31 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.BoolPar;

public class	LetPrim extends AssignPrim {

    public LetPrim(String name) { super(name); }

    protected void	assign(Token src, boolean glob) {
	Token		tok = definableToken();
	Command		cmd = newMeaning();
	if (cmd.sameAs(Undefined.getUndefined())) cmd = Command.NULL;
	tok.define(cmd, glob);
    }

    protected Command	newMeaning() {
	BoolPar		exp = new BoolPar();
	Token		tok;
	Command		cmd;
	do {
	    tok = nextRawToken(exp);
	    cmd = meaningOf(tok, exp.get());
	} while (cmd.isSpacer());
	if (tok.matchOther('=')) {
	    tok = nextRawToken(exp);
	    cmd = meaningOf(tok, exp.get());
	    if (cmd.isSpacer()) {
		tok = nextRawToken(exp);
		cmd = meaningOf(tok, exp.get());
	    }
	}
	return cmd;
    }

}
