/* $Id: LineInputReadInput.java,v 1.1.1.1 1999/05/31 11:18:48 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.io.InputLine;
import	nts.io.LineInput;

public class	LineInputReadInput	implements ReadInput {

    public interface	InputHandler {
	InputLine	emptyLine();
	Tokenizer	makeTokenizer(InputLine line, String desc,
				      boolean addEolc);
    }

    /** The underlying line oriented input reader */
    private LineInput		input;

    /** The parametrization object */
    private InputHandler	inpHandler;

    private String		desc;

    /**
     * Creates an |LineInputReadInput| with given input and parametrization
     * object.
     * @param	input the underlying reader.
     * @param	inpHandler the parametrization object.
     */
    public LineInputReadInput(LineInput input, InputHandler inpHandler,
			      int num) {
	this.input = input;
	this.inpHandler = inpHandler;
	desc = "<read " + num + "> ";
    }

    /**
     * Closes the underlying |LineInput|.
     */
    public void		close() { input.close(); }

    public Tokenizer	nextTokenizer(Token def, int ln) {
	InputLine	line = input.readLine();
	return (line == LineInput.EOF) ? Tokenizer.NULL
	     : inpHandler.makeTokenizer(line, desc, true);
    }

    public Tokenizer	emptyLineTokenizer()
	{ return inpHandler.makeTokenizer(inpHandler.emptyLine(), desc, true); }

}
