/* $Id: MagParam.java,v 1.1.1.1 1999/07/12 11:04:07 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Num;

/**
 * Setting number parameter primitive.
 */
public class	MagParam extends NumParam {

    /**
     * Creates a new MagParam with given name and value and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the MagParam
     * @param	val the value of the MagParam
     */
    public	MagParam(String name, Num val) { super(name, val); }
    public	MagParam(String name, int val) { super(name, val); }

    /**
     * Creates a new MagParam with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the MagParam
     */
    public	MagParam(String name) { super(name); }

    private Num		magSet = Num.NULL;

    public Num		get() {
        Num		mag = super.get();
        if (magSet != Num.NULL && !magSet.equals(mag)) {
	    error("IncompatMag", str(mag), str(magSet));
	    mag = magSet; set(mag, true);
	}
	if (!mag.moreThan(0) || mag.moreThan(32768)) {
	    error("IllegalMag", str(mag));
	    mag = Num.valueOf(1000); set(mag, true);
	}
	magSet = mag;
	return mag;
    }

}
