/* $Id: MuSkipPrim.java,v 1.1.1.1 1999/05/31 11:18:49 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Glue;
import	nts.io.Log;

/**
 * Setting glue register primitive.
 */
public class	MuSkipPrim	extends RegisterPrim {

    /**
     * Creates a new |MuSkipPrim| with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the |MuSkipPrim|
     */
    public MuSkipPrim(String name) { super(name); }

    public final void	set(int idx, Glue val, boolean glob) {
	if (glob) getEqt().gput(tabKind, idx, val);
	else getEqt().put(tabKind, idx, val);
    }

    public final Glue	get(int idx) {
        Glue	val = (Glue) getEqt().get(tabKind, idx);
	return (val != Glue.NULL) ? val : Glue.ZERO;
    }

    public void		addEqValueOn(int idx, Log log)
	{ log.add(get(idx).toString("mu")); }

    public void		perform(int idx, int operation, boolean glob)
	{ set(idx, performFor(get(idx), operation, true), glob); }

    /**
     * Performs the assignment.
     * @param	src source token for diagnostic output.
     * @param	glob indication that the assignment is global.
     */
    protected final void	assign(Token src, boolean glob) {
	int	idx = scanRegisterCode();
        skipOptEquals();
	set(idx, scanMuGlue(), glob);
    }

    public final void	perform(int operation, boolean glob, Command after)
	{ perform(scanRegisterCode(), operation, glob); }

    public boolean	hasMuGlueValue() { return true; }
    public Glue		getMuGlueValue() { return get(scanRegisterCode()); }

}
