/* $Id: NormalCharToken.java,v 1.1.1.1 1999/08/16 12:11:05 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.io.CharCode;

public abstract class	NormalCharToken extends CharToken {

    public NormalCharToken(CharCode code) { super(code); }

    public boolean	matchNormal(char c) { return code.match(c); }

    /**
     * Gives the 7 bit ascii character code of this normal (letter or other)
     * character |Token|.
     * The result is |CharCode.NO_CHAR| if its character code is not
     * a 7 bit ascii.
     * @return	the 7 bit ascii code if the code is defined,
     *		|CharCode.NO_CHAR| otherwise.
     */
    public char		normalChar() { return code.toChar(); }

    public String	toString() { return "<NormalChar: " + code + '>'; }

    private static CharHandler		handler;

    public static void		setHandler(CharHandler hnd) { handler = hnd; }

    public abstract class	Meaning	extends CharToken.Meaning {
	public void	exec(Token src) { handler.handle(code, src); }
	public CharCode	charCodeToAdd() { return code; }
    }

}
