/* $Id: OtherToken.java,v 1.1.1.1 2000/02/16 11:01:06 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.io.CharCode;

public class	OtherToken extends NormalCharToken {

    public static final Maker		MAKER = new Maker() {
        public Token	make(CharCode code)
	    { return new OtherToken(code); }
    };

    public OtherToken(CharCode code) { super(code); }

    public boolean	matchOther(char c) { return code.match(c); }

    /**
     * Gives the 7 bit ascii character code of this other character |Token|.
     * The result is |CharCode.NO_CHAR| if its character code is not
     * a 7 bit ascii.
     * @return	the 7 bit ascii code if the code is defined,
     *		|CharCode.NO_CHAR| otherwise.
     */
    public char		otherChar() { return code.toChar(); }

    public boolean	match(CharToken tok)
	{ return (tok instanceof OtherToken && tok.match(code)); }

    public Maker	getMaker() { return MAKER; }

    public String	toString() { return "<Other: " + code + '>'; }

    public Command	meaning() {
	return new Meaning() {
	    protected String	description() { return "the character"; }
	};
    }

}
