/* $Id: Prefix.java,v 1.1.1.1 2001/03/22 13:43:20 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

/**
 * Prefix Prim which can prefix definition or assignment
 * with LONG, OUTER or GLOBAL.
 */
public class	Prefix	extends PrefixPrim {

    /** Built in prefixes (LONG, OUTER, GLOBAL) */
    private final int			prefix;

    /** Creates and registers the prefix primitive */
    public Prefix(String name, int prefix)
        { super(name); this.prefix = prefix; }

    public void		exec(Token src, int prefixes) {
    	Token		tok = nextExpToken();
	meaningOf(tok).execute(tok, prefixes | prefix);
    }

    public void		doAssignment(Token src, int prefixes) {
    	Token		tok = nextExpToken();
	meaningOf(tok).doAssignment(tok, prefixes | prefix);
    }

}
