/* $Id: ScanToksChecker.java,v 1.1.1.1 1999/05/31 11:18:51 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.BoolPar;
import	nts.io.Loggable;
import	nts.io.MaxLoggable;

public class	ScanToksChecker	extends BaseToksChecker {

    protected final String		desc;
    protected final MaxLoggable		list;
    protected final Token		insTok;

    public ScanToksChecker(String tokErr, String eofErr,
    			   String desc, MaxLoggable list,
			   Loggable src, Token ins) {
	super(tokErr, eofErr, src);
	this.desc = desc; this.list = list;
	insTok = ins;
    }

    public ScanToksChecker(String tokErr, String eofErr,
    			   String desc, MaxLoggable list, Loggable src) {
	super(tokErr, eofErr, src);
	this.desc = desc; this.list = list;
	insTok = RightBraceToken.TOKEN;
    }

    protected void	tryToFix()
	{ Command.insertTokenWithoutCleaning(insTok); }

    protected void	reportRunAway()
	{ Command.runAway(desc, list); }

}
