/* $Id: SimpleNumPrim.java,v 1.1.1.1 1999/07/23 07:27:06 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.base.Num;

public class	SimpleNumPrim	extends Prim
				implements Num.Provider {

    private Num		value;

    public SimpleNumPrim(String name, Num val)
	{ super(name); value = val; }

    public SimpleNumPrim(String name, int val)
	{ this(name, Num.valueOf(val)); }

    public SimpleNumPrim(String name) { this(name, Num.ZERO); }

    /* STRANGE
     * why does it talk about curren mode?
     */
    public void		exec(Token src) { illegalCommand(this); }

    public Num		get() { return value; }
    public void		set(Num val) { value = val; }
    public final int	intVal() { return get().intVal(); }
    public final void	set(int val) { set(Num.valueOf(val)); }
    public boolean	hasNumValue() { return true; }
    public Num		getNumValue() { return get(); }

}
