/* $Id: ToksParam.java,v 1.1.1.1 2000/01/05 00:41:15 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.command;

import	nts.io.Log;

/**
 * Setting tokens parameter primitive.
 */
public class	ToksParam	extends ParamPrim
				implements TokenList.Provider,
					   TokenList.Inserter {

    private TokenList		value;

    /**
     * Creates a new ToksParam with given name and value and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the ToksParam
     * @param	val the value of the ToksParam
     */
    public	ToksParam(String name, TokenList val)
	{ super(name); value = val; }

    /**
     * Creates a new ToksParam with given name and stores it
     * in language interpreter |EqTable|.
     * @param	name the name of the ToksParam
     */
    public	ToksParam(String name) { this(name, TokenList.EMPTY); }

    public final Object		getEqValue() { return value; }

    public final void	setEqValue(Object val) { value = (TokenList) val; }

    public final void	addEqValueOn(Log log)
	{ value.addOn(log, getConfig().getIntParam(INTP_MAX_TLRES_TRACE)); }

    public final TokenList	get() { return value; }

    public void			set(TokenList val, boolean glob)
	{ beforeSetting(glob); value = val; }

    protected void	scanValue(Token src, boolean glob)
        { set(scanToksValue(src), glob); }

    protected TokenList	scanToksValue(Token src)
	{ return scanToks(src, false); }

    public boolean	hasToksValue() { return true; }
    public TokenList	getToksValue() { return value; }

    public void		insertToks()
	{ tracedPushList(value, getName()); }

    public boolean	isEmpty() { return (value.isEmpty()); }

}
