/* $Id: HyphNode.java,v 1.1.1.1 2000/11/10 16:25:59 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.hyph;

import	java.io.Serializable;

public class	HyphNode	implements Serializable {

    public static final HyphNode	NULL = null;
    public static final HyphNode	ZERO = new HyphNode(0, 0, NULL);

    public final int		offset;
    public final int		value;
    public final HyphNode	next;

    public HyphNode(int offset, int value, HyphNode next)
	{ this.offset = offset; this.value = value; this.next = next; }

    public boolean	equals(Object obj) {
	if (obj == this) return true;
	if (!(obj instanceof HyphNode)) return false;
	HyphNode	that = (HyphNode) obj;
	return (  offset == that.offset
	       && value == that.value
	       && next == that.next  );
    }

    public boolean	isZero()
	{ return (offset == 0 && value == 0 && next == NULL); }

    public int		hashCode() {
	int		code = 0;
	HyphNode	hyph = this;
	do {
	    code += 313 * (1009 * hyph.offset + hyph.value);
	    hyph = hyph.next;
	} while (hyph != NULL);
	return code;
    }

    public String	toString() {
	StringBuffer	buf = new StringBuffer();
	HyphNode	hyph = this;
	do {
	    buf.append(" ->").append(hyph.offset)
	       .append(": ").append(hyph.value);
	    hyph = hyph.next;
	} while (hyph != NULL);
	return buf.toString();
    }

}
