/* $Id: CharCode.java,v 1.1.1.1 2001/02/03 07:20:48 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.io;

import	java.io.Writer;
import	java.io.IOException;
import	java.io.Serializable;
import	nts.base.Num;

public interface	CharCode	extends Serializable, Loggable {

    /** The reference to non existent internal character code */
    CharCode		NULL = null;

    /** Symbolic constant for non ascii caharacter code */
    char		NO_CHAR = 0xffff;

    public interface CodeWriter { void writeCode(CharCode code); }
    public interface CharWriter { void writeChar(char chr); }

    public interface Maker {
    	CharCode	make(char chr);
    	CharCode	make(int num);
	boolean		isNewLine(char chr);
	void		writeExpCodes(char chr, CodeWriter out);
	void		writeExpChars(char chr, CharWriter out);
    }

    char		toChar();
    int			numValue();
    char		toCanonicalLetter();
    boolean		match(CharCode x);
    boolean		match(char c);
    boolean		match(int num);
    boolean		match(Num num);
    CharCode		toLowerCase();
    CharCode		toUpperCase();
    int			spaceFactor();
    int			mathCode();
    int			delCode();
    boolean		isLetter();
    boolean		isEscape();
    boolean		isEndLine();
    boolean		isNewLine();
    boolean		startsExpand();
    boolean		startsFileExt();
    void		writeExpCodes(CodeWriter out);
    void		writeExpChars(CharWriter out);
    void		writeRawChars(CharWriter out);

}
