/* $Id: DoubleLineOutput.java,v 1.1.1.1 1999/04/19 07:37:15 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.io;

public final class	DoubleLineOutput	extends LineOutput {

    LineOutput		first;
    LineOutput		second;

    public DoubleLineOutput(LineOutput first, LineOutput second)
	{ this.first = first; this.second = second; }

    public final void		add(char ch)
	{ first.add(ch); second.add(ch); }

    public final void		add(String str)
	{ first.add(str); second.add(str); }

    public final void		add(CharCode code)
	{ first.add(code); second.add(code); }

    public final void		endLine()
	{ first.endLine(); second.endLine(); }

    public final void		flush()
	{ first.flush(); second.flush(); }

    public final void		close()
	{ first.close(); second.close(); }

    public final void		setStartLine()
	{ first.setStartLine(); second.setStartLine(); }

    public final boolean	isStartLine()
	{ return (first.isStartLine() && second.isStartLine()); }

    public final boolean	stillFits(int count)
	{ return (first.stillFits(count) && second.stillFits(count)); }

    public final void		resetCount()
	{ first.resetCount(); second.resetCount(); }

    public final int		getCount() {
	int	x = first.getCount();
	int	y = second.getCount();
	return (x > y) ? x : y;
    }

    public final LineOutput	voidCounter() {
	return new DoubleLineOutput(first.voidCounter(),
				    second.voidCounter());
    }

}
