/* $Id: LineOutput.java,v 1.1.1.1 2000/01/27 14:30:40 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.io;

public abstract class	LineOutput {

    public static final LineOutput	NULL = null;

    public abstract void	add(char ch);
    public abstract void	add(String str);
    public abstract void	add(CharCode code);
    public abstract void	endLine();
    public abstract void	setStartLine();
    public abstract boolean	isStartLine();
    public abstract boolean	stillFits(int count);
    public abstract void	resetCount();
    public abstract int		getCount();
    public abstract LineOutput	voidCounter();

    public void		startLine()
	{ if (!isStartLine()) endLine(); }

    public void	flush() { }
    public void	close() { }

}
