/* $Id: StringLineOutput.java,v 1.1.1.1 2001/02/06 12:31:47 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.io;

public final class	StringLineOutput	extends BaseLineOutput
					implements CharCode.CharWriter {

    private final StringBuffer		buf;

    public StringLineOutput(StringBuffer buf) { this.buf = buf; }
    public StringLineOutput() { buf = new StringBuffer(); }

    public StringBuffer	getBuffer() { return buf; }
    public String	toString() { return buf.toString(); }
    public void		add(CharCode code) { code.writeRawChars(this); }
    public void		add(char chr) { buf.append(chr); }
    public void		writeChar(char chr) { buf.append(chr); }

}
