/* $Id: DelCodePrim.java,v 1.1.1.1 1999/12/12 23:59:52 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.base.Num;
import	nts.command.Token;
import	nts.command.DefCodePrim;

/**
 */
public class	DelCodePrim	extends DefCodePrim {

    public DelCodePrim(String name, int defVal, int maxVal)
	{ super(name, defVal, maxVal); }

    /**
     * Performs the assignment.
     * @param	src source token for diagnostic output.
     * @param	glob indication that the assignment is global.
     */
    /* TeXtp[1232] */
    protected final void	assign(Token src, boolean glob) {
	int	idx = scanCharacterCode();
        skipOptEquals();
	int	val = scanInt();
	if (val > maxVal)
	    { error("CodeGreater", num(val), num(maxVal)); val = 0; }
	set(idx, Num.valueOf(val), glob);
    }

}
