/* $Id: EqNoGroup.java,v 1.1.1.1 2000/10/18 10:31:00 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.node.NodeList;
import	nts.node.HBoxNode;
import	nts.noad.Noad;
import	nts.noad.Conversion;
import	nts.noad.ConvStyle;
import	nts.builder.Builder;
import	nts.typo.TypoCommand;

public class	EqNoGroup	extends FormulaGroup {

    private /* final */ boolean	left;

    public EqNoGroup(FormulaBuilder builder, boolean left)
	{ super(builder); this.left = left; }

    public EqNoGroup(boolean left)
	{ this(new FormulaBuilder(currLineNumber()), left); }

    /* TeXtp[1194] */
    public void		stop() {
	Builder.pop();
	MathBuilder	bld = (MathBuilder) TypoCommand.getBld();
	Config		cfg = getConfig();
	boolean		success = necessaryParamsDefined();
	expectAnotherMathShift();
	NodeList	list = (success)
			     ? Conversion.madeOf(builder.getList().noads(),
				    new FormulaStyle(Noad.TEXT_STYLE, false))
			     : NodeList.EMPTY;
	HBoxNode	box = HBoxNode.packedOf(list);
	bld.setEqNo(box, left);
    }

    public void		close() { popLevel(); }

}
