/* $Id: EqNoPrim.java,v 1.1.1.1 2001/03/13 05:28:04 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.command.Token;
import	nts.command.TokenList;
import	nts.command.Command;
import	nts.command.Group;
import	nts.command.Closing;

public class	EqNoPrim	extends AdaptMathPrim {

    private /* final */ TokenList.Inserter	every;
    private /* final */ boolean			left;

    public EqNoPrim(String name, Command command,
		    TokenList.Inserter every, boolean left)
	{ super(name, command); this.every= every; this.left = left; }

    protected class	DisplayedClosing	extends Closing {
	
	/* TeXtp[1142] */
	public void		exec(Group grp, Token src) {
	    pushLevel(new EqNoGroup(left));
	    MathPrim.getMathConfig().initFormula();
	    every.insertToks();
	}

    }

    public Closing	makeDisplayedClosing()
	{ return new DisplayedClosing(); }

}
