/* $Id: FractionPrim.java,v 1.1.1.1 2000/03/09 16:56:16 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.base.Dimen;
import	nts.noad.Delimiter;
import	nts.command.Token;

public class	FractionPrim	extends MathPrim {

    public static final byte	ZERO_THICKNESS = 0;
    public static final byte	DEFAULT_THICKNESS = 1;
    public static final byte	EXPLICIT_THICKNESS = 2;

    private /* final */ boolean	withDelims;
    private /* final */ byte		thickMode;

    public	FractionPrim(String name, boolean withDelims,
			     byte thickMode) {
	super(name);
	this.withDelims = withDelims;
	this.thickMode = thickMode;
    }

    public MathAction	mathAction() { return NORMAL; }

    /* TeXtp[1181] */
    public final MathAction	NORMAL = new MathAction() {
	public void		exec(final MathBuilder bld, Token src) {
	    Delimiter		left = Delimiter.NULL;
	    Delimiter		right = Delimiter.NULL;
	    Dimen		thickness;
	    if (withDelims)
		{ left = scanDelimiter(); right = scanDelimiter(); }
	    switch (thickMode) {
		case EXPLICIT_THICKNESS:
		    thickness = scanDimen(); break;
		case ZERO_THICKNESS:
		    thickness = Dimen.ZERO; break;
		default:
		    thickness = Dimen.NULL; break;
	    }
	    if (bld.alreadyFractioned()) error("AmbiguousFraction");
	    else if (withDelims) bld.fractione(thickness, left, right);
	    else bld.fractione(thickness);
	}
    };

}
