/* $Id: LeftGroup.java,v 1.1.1.1 2001/03/22 16:13:36 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.noad.Noad;
import	nts.noad.TreatNoadList;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.TokenList;
import	nts.command.OtherToken;
import	nts.command.SimpleGroup;

public class	LeftGroup	extends SimpleGroup {

    private final Token			expected;
    private final TreatNoadList		proc;
    protected final FormulaBuilder	builder;

    public LeftGroup(Token expected, TreatNoadList proc,
		     FormulaBuilder builder) {
	this.expected = expected; this.proc = proc;
	this.builder = builder;
    }

    public LeftGroup(Token expected, TreatNoadList proc, Noad leftDelim) {
	this.expected = expected; this.proc = proc;
	builder = new FormulaBuilder(currLineNumber(), leftDelim);
    }

    public void		start() { Builder.push(builder); }

    /* TeXtp[1191] */
    public void		stop()
	{ Builder.pop(); proc.execute(builder.getList()); }

    public Token	expectedToken() { return expected; }

    /* TeXtp[1065] */
    public void		reject(Token tok) {
        backToken(tok);
	TokenList.Buffer	buf = new TokenList.Buffer(2);
	buf.append(expected);	//XXX make ins on demand and keep it
	buf.append(new OtherToken(Token.makeCharCode('.')));
	TokenList	ins = buf.toTokenList();
	insertList(ins); error("MissingInserted", ins);
    }

}
