/* $Id: LeftPrim.java,v 1.1.1.1 2000/08/05 16:20:27 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.noad.LeftNoad;
import	nts.noad.RightNoad;
import	nts.noad.InnerNoad;
import	nts.noad.NoadList;
import	nts.noad.TreatNoadList;
import	nts.noad.NoadListField;
import	nts.command.Token;
import	nts.command.FrozenToken;
import	nts.command.Primitive;
import	nts.command.Group;
import	nts.command.Closing;

public class	LeftPrim	extends MathPrim {

    public /* final */ Token		rightTok;

    public	LeftPrim(String name, Primitive right)
	{ super(name); rightTok = new FrozenToken(right); }

    public MathAction	mathAction() { return NORMAL; }

    /* TeXtp[1191,1184] */
    public final MathAction	NORMAL = new MathAction() {
	public void		exec(final MathBuilder bld, Token src) {
	    final LeftNoad	left = new LeftNoad(scanDelimiter());
	    pushLevel(new LeftGroup(rightTok, new TreatNoadList() {
		public void	execute(NoadList list) {
		    RightNoad	right = new RightNoad(scanDelimiter());
		    NoadList	whole = new NoadList(left);
		    whole.append(list).append(right);
		    bld.addNoad(new InnerNoad(new NoadListField(whole)));
		}
	    }, left));
	}
    };

    /* TeXtp[1192] */
    public static final Closing		EXTRA_RIGHT = new Closing() {
	public void	exec(Group grp, Token src)
	    { MathPrim.scanDelimiter(); error("ExtraRight", src); }
    };

}
