/* $Id: MSkipPrim.java,v 1.1.1.1 2000/03/02 14:10:35 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.base.Glue;
import	nts.noad.MSkipNoad;
import	nts.builder.Builder;
import	nts.command.Token;

public class	MSkipPrim	extends MathPrim {

    private final Glue		skip;

    public MSkipPrim(String name, Glue skip)
	{ super(name); this.skip = skip; }

    public MSkipPrim(String name)
	{ super(name); this.skip = Glue.NULL; }

    public Glue		getSkip()
	{ return (skip != Glue.NULL) ? skip : scanMuGlue(); }

    public MathAction	mathAction() { return NORMAL; }

    /* TeXtp[1057,1060] */
    public final MathAction		NORMAL = new MathAction() {

	public void	exec(MathBuilder bld, Token src)
	    { bld.addNoad(new MSkipNoad(getSkip())); }

	public Glue	getSkipForLeaders(Builder bld) { return getSkip(); }

    };

}
