/* $Id: MathCharDefPrim.java,v 1.1.1.1 2001/03/22 15:52:06 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.base.Num;
import	nts.io.Log;
import	nts.command.Token;
import	nts.command.Command;
import	nts.command.Relax;
import	nts.command.AssignPrim;
import	nts.command.Primitive;

public class	MathCharDefPrim	extends AssignPrim {

    private Primitive		prim;

    public MathCharDefPrim(String name, Primitive prim)
	{ super(name); this.prim = prim; }

    protected void	assign(Token src, boolean glob) {
	Token	tok = definableToken();
	tok.define(Relax.getRelax(), glob);
	skipOptEquals();
	int	code = MathPrim.scanMathCharCode();	//XXX int
	tok.define(new MathGiven(code, prim.getName()), glob);

	// CharCode	code = Token.makeCharCode(scanMathCharCode());
	// if (code != CharCode.NULL)
	    // tok.define(new MathGiven(code, prim.getName()), glob);
	// else throw new RuntimeException("no mathchar number scanned");
    }

}

class	MathGiven	extends Command	implements Num.Provider {

    private int			code;	//XXX int
    private String		name;

    public MathGiven(int code, String name)
	{ this.code = code; this.name = name; }

    public void		exec(Token src)
	{ MathPrim.handleMathCode(code, src); }

    public boolean	hasMathCodeValue() { return true; }
    public int		getMathCodeValue() { return code; }

    public boolean	sameAs(Command cmd) {
	return (  cmd instanceof MathGiven
	       && code == ((MathGiven) cmd).code  );
    }

    public void		addOn(Log log) {
        log.addEsc(name).add('"')
	   .add(Integer.toHexString(code).toUpperCase());
    }

    public boolean  hasNumValue() { return true; }
    public Num      getNumValue() { return Num.valueOf(code); }

    public final String	toString()
	{ return "[mathchar given: " + code + ']'; }

}
