/* $Id: MathChoicePrim.java,v 1.1.1.1 2000/03/20 21:16:46 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.noad.Noad;
import	nts.noad.NoadList;
import	nts.noad.ChoiceNoad;
import	nts.command.Token;

public class	MathChoicePrim	extends MathPrim {

    public	MathChoicePrim(String name) { super(name); }

    public MathAction	mathAction() { return NORMAL; }

    /* STRANGE
     * Empty Noad is added and then removed only for the case when
     * \showlists appear inside the group.
     */
    /* TeXtp[1172] */
    public final MathAction	NORMAL = new MathAction() {
	public void		exec(final MathBuilder bld, Token src) {
	    NoadList[]		choices = new NoadList[Noad.NUMBER_OF_STYLES];
	    for (int i = 0; i < choices.length; i++)
		choices[i] = NoadList.EMPTY;
	    bld.addNoad(new ChoiceNoad(choices));
	    pushLevel(new MathChoiceGroup(choices));
	}
    };

}
