/* $Id: MathGroup.java,v 1.1.1.1 2001/03/09 11:06:16 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.builder.Builder;
import	nts.noad.NoadList;
import	nts.noad.Field;
import	nts.noad.TreatField;
import	nts.noad.VoidField;
import	nts.noad.NoadListField;
import	nts.command.SimpleGroup;

public class	MathGroup	extends SimpleGroup {

    protected final TreatField		proc;
    protected final FormulaBuilder	builder;

    public MathGroup(TreatField proc, FormulaBuilder builder)
	{ this.proc = proc; this.builder = builder; }

    public MathGroup(TreatField proc)
	{ this(proc, new FormulaBuilder(currLineNumber())); }

    public void		start() { Builder.push(builder); }

    /* TeXtp[1186] */
    public void		close() {
	Builder.pop();
	NoadList	list = builder.getList();
	Field		field = Field.NULL;
	if (list.isEmpty()) field = VoidField.FIELD;
	else {
	    if (list.length() == 1)
		field = list.noadAt(0).ordinaryField();
	    if (field == Field.NULL)
		field = new NoadListField(list);
	}
	proc.execute(field);
    }

}
