/* $Id: MathShiftToken.java,v 1.1.1.1 2000/04/16 10:46:47 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.io.CharCode;
import	nts.command.Token;
import	nts.command.CharToken;
import	nts.command.Command;

public class	MathShiftToken	extends CharToken {

    public static final CharCode	CODE = makeCharCode('$');
    public static final MathShiftToken	TOKEN = new MathShiftToken(CODE);

    public static final Maker		MAKER = new Maker() {
        public Token	make(CharCode code)
	    { return new MathShiftToken(code); }
    };

    public MathShiftToken(CharCode code) { super(code); }

    public boolean	match(CharToken tok)
	{ return (tok instanceof MathShiftToken && tok.match(code)); }

    public Maker	getMaker() { return MAKER; }

    public String	toString() { return "<MathShift: " + code + '>'; }

    private static Command		command;
    public static void		setCommand(Command cmd) { command = cmd; }

    public Command	meaning() {
	return new Meaning() {

	    public boolean	isMathShift() { return true; }
	    public void		exec(Token src) { command.exec(src); }

	    protected String	description()
		{ return "math shift character"; }

	};
    }

}
