/* $Id: RadicalPrim.java,v 1.1.1.1 2000/03/02 15:03:24 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.noad.Field;
import	nts.noad.EmptyField;
import	nts.noad.TreatField;
import	nts.noad.Delimiter;
import	nts.noad.RadicalNoad;
import	nts.command.Token;

public class	RadicalPrim	extends MathPrim {

    public	RadicalPrim(String name) { super(name); }

    public MathAction	mathAction() { return NORMAL; }

    /* STRANGE
     * Empty Noad is added and then removed only for the case when
     * \showlists appear inside the group.
     */
    /* TeXtp[1163] */
    public final MathAction	NORMAL = new MathAction() {
	public void		exec(final MathBuilder bld, Token src) {
	    final Delimiter	radical
		= getMathConfig().delimiterForDelCode(scanDelimiterCode());
	    bld.addNoad(new RadicalNoad(radical, EmptyField.FIELD));
	    scanField(new TreatField() {
		public void	execute(Field field)
		    { bld.replaceLastNoad(new RadicalNoad(radical, field)); }
	    });
	}
    };

}
