/* $Id: ScriptPrim.java,v 1.1.1.1 2000/03/03 19:22:59 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.noad.Noad;
import	nts.noad.OrdNoad;
import	nts.noad.Field;
import	nts.noad.EmptyField;
import	nts.noad.TreatField;
import	nts.command.Token;

public abstract class	ScriptPrim	extends MathPrim {

    public	ScriptPrim(String name) { super(name); }

    public MathAction	mathAction() { return NORMAL; }

    /* TeXtp[1176] */
    public final MathAction	NORMAL = new MathAction() {
	public void		exec(final MathBuilder bld, Token src) {
	    Noad	last = bld.lastNoad();
	    boolean	scriptable = false;
	    if (last != Noad.NULL && last.isScriptable()) {
		scriptable = true;
		if (conflicting(last))
		    { error(errorIdent()); scriptable = false; }
	    }
	    final Noad		body;
	    if (scriptable) body = last;
	    else { body = new OrdNoad(EmptyField.FIELD); bld.addNoad(body); }
	    scanField(new TreatField() {
		public void	execute(Field field)
		    { bld.replaceLastNoad(scripted(body, field)); }
	    });
	}
    };

    protected abstract boolean		conflicting(Noad noad);
    protected abstract Noad		scripted(Noad noad, Field script);
    protected abstract String		errorIdent();

}
