/* $Id: VCenterPrim.java,v 1.1.1.1 2000/08/03 14:27:44 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.math;

import	nts.base.Dimen;
import	nts.node.Box;
import	nts.node.TreatBox;
import	nts.node.NodeEnum;
import	nts.noad.NodeField;
import	nts.noad.VCenterNoad;
import	nts.command.Token;
import	nts.command.TokenList;

public class	VCenterPrim	extends MathPrim {

    private final TokenList.Inserter	every;

    public VCenterPrim(String name, TokenList.Inserter every)
	{ super(name); this.every = every; }

    public MathAction	mathAction() { return NORMAL; }

    /* TeXtp[1167] */
    public final MathAction	NORMAL = new MathAction() {
	public void		exec(final MathBuilder bld, Token src) {
	    makeBoxValue(new TreatBox() {
		public void		execute(Box box, NodeEnum mig)
		    { bld.addNoad(new VCenterNoad(new NodeField(box))); }
	    });
	}
    };

    /* TeXtp[645] */
    public void		makeBoxValue(TreatBox proc) {
	Dimen		size = Dimen.ZERO;
	boolean		exactly = false;
	if (scanKeyword("to")) { size = scanDimen(); exactly = true; }
	else if (scanKeyword("spread")) size = scanDimen();
	pushLevel(new VCenterGroup(size, exactly, proc));
	scanLeftBrace(); every.insertToks();
    }

}
