/* $Id: ChoiceNoad.java,v 1.1.1.1 2000/04/07 15:08:50 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.Node;

public class	ChoiceNoad	extends PureNoad {

    private final NoadList[]		choices;

    public ChoiceNoad(NoadList[] choices) {
	this.choices = choices;
	if (choices.length != NUMBER_OF_STYLES)
	    throw new RuntimeException("Bad size of math choices");
    }

    public final boolean	influencesBin() { return false; }

    /* TeXtp[731] */
    public Egg		convert(Converter conv) {
	conv.push(choices[conv.getStyle()].noads());
	return VoidEgg.EGG;
    }

    /* TeXtp[695] */
    public void		addOn(Log log, CntxLog cntx) {
	log.addEsc(getDesc());
	for (byte i = 0; i < NUMBER_OF_STYLES; i++)
	    cntx.addOn(log, choices[i].noads(), getStylePrefix(i));
    }

    protected String		getDesc() { return "mathchoice"; }

    private static final char[]		stylePrefixes
	= new char[NUMBER_OF_STYLES];

    static {
	stylePrefixes[DISPLAY_STYLE] = 'D';
	stylePrefixes[TEXT_STYLE] = 'T';
	stylePrefixes[SCRIPT_STYLE] = 'S';
	stylePrefixes[SCRIPT_SCRIPT_STYLE] = 's';
    }

    public static char		getStylePrefix(byte style)
	{ return stylePrefixes[style]; }

}
