/* $Id: Field.java,v 1.1.1.1 2000/10/17 13:26:15 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	java.io.Serializable;
import	nts.base.Dimen;
import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.Node;
import	nts.node.HBoxNode;
import	nts.node.TreatNode;
import	nts.node.MathWordBuilder;

public abstract class	Field	implements Serializable, TransfConstants {

    public static final Field	NULL = null;

    public abstract void	addOn(Log log, CntxLog cntx, char p);

    public Noad		ordinaryNoad() { return Noad.NULL; }
    public boolean	isEmpty() { return false; }
    public boolean	isJustChar() { return false; }
    public Dimen	skewAmount(Converter conv) { return Dimen.ZERO; }
    public Node		convertedBy(Converter conv) { return Node.NULL; }

    /* STRANGE
     * why is cleanBox(x, CURRENT) != convertedBy(x)?
     */
    public Node		cleanBox(Converter conv, byte how)
	{ return HBoxNode.EMPTY; }

    public Operator	makeOperator(final Converter conv,
				     final boolean larger) {
	return new  Operator() {

	    public Node		getNodeToBeLimited()
		{ return cleanBox(conv, CURRENT); }

	    public Egg		getEggToBeScripted(byte spType)
		{ return new StItalNodeEgg(convertedBy(conv), spType); }

	    public Dimen	getItalCorr() { return Dimen.NULL; }

	};
    }

    public MathWordBuilder	getMathWordBuilder(Converter conv,
						   TreatNode proc) {
	throw new RuntimeException(
		    "non char field cannot provide math word builder");
    }

    public byte		wordFamily() { return -1; }
    public void		contributeToWord(MathWordBuilder word) { }

    public Operator	takeLastOperator(MathWordBuilder word,
					 Converter conv,
					 boolean larger) {
	throw new RuntimeException(
		    "non char field cannot be part of math word");
    }

}
