/* $Id: FollowNodeEgg.java,v 1.1.1.1 2000/04/11 00:21:01 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.base.Dimen;
import	nts.node.Node;

public class	FollowNodeEgg	extends Egg {
 
    private final Egg		egg;
    private final Node		node;

    public FollowNodeEgg(Egg egg, Node node)
	{ this.egg = egg; this.node = node; }

    public Dimen	getHeight()
	{ return egg.getHeight().max(node.getHeight()); }

    public Dimen	getDepth()
	{ return egg.getDepth().max(node.getDepth()); }

    public void		chipShell(Nodery nodery)
	{ egg.chipShell(nodery); nodery.append(node); }

    public byte		spacingType() { return egg.spacingType(); }

}
