/* $Id: MKernNoad.java,v 1.1.1.1 2000/05/26 21:14:42 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.base.Dimen;
import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.Node;
import	nts.node.HKernNode;

public class	MKernNoad	extends BaseNodeNoad {

    private /* final */ Dimen		mkern;

    public MKernNoad(Dimen mkern) { this.mkern = mkern; }

    public Egg		convert(Converter conv)
	{ return new SimpleNodeEgg(new HKernNode(conv.muToPt(mkern))); }

    public void		addOn(Log log, CntxLog cntx)
	{ log.addEsc("mkern").add(mkern.toString("mu")); }

    public Node		getNode() { return new InternalKernNode(); }

    protected class InternalKernNode	extends HKernNode {
	/* corresponding to kern_node */
	public InternalKernNode() { super(MKernNoad.this.mkern); }
	public boolean		isMuKern() { return true; }
	public Dimen		getMuKern() { return mkern; }
	public void		addOn(Log log, CntxLog cntx)
	    { MKernNoad.this.addOn(log, cntx); }
    }

}
