/* $Id: MSkipNoad.java,v 1.1.1.1 2000/05/26 21:14:42 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.base.Glue;
import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.Node;
import	nts.node.HSkipNode;

public class	MSkipNoad	extends BaseNodeNoad {

    private /* final */ Glue		mskip;

    public MSkipNoad(Glue mskip) { this.mskip = mskip; }

    public Egg		convert(Converter conv)
	{ return new SimpleNodeEgg(new HSkipNode(conv.muToPt(mskip))); }

    public void		addOn(Log log, CntxLog cntx) {
	log.addEsc("glue").add('(').addEsc("mskip").add(')')
	   .add(' ').add(mskip.toString("mu"));
    }

    public Node		getNode() { return new InternalSkipNode(); }

    protected class InternalSkipNode	extends HSkipNode {
	/* corresponding to glue_node */
	public InternalSkipNode() { super(MSkipNoad.this.mskip); }
	public boolean		isMuSkip() { return true; }
	public Glue		getMuSkip() { return mskip; }
	public void		addOn(Log log, CntxLog cntx)
	    { MSkipNoad.this.addOn(log, cntx); }
    }

}
