/* $Id: Noad.java,v 1.1.1.1 2000/10/17 13:34:53 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	java.io.Serializable;
import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.io.CntxLoggable;
import	nts.node.Node;
import	nts.node.TreatNode;
import	nts.node.MathWordBuilder;

public interface	Noad	extends Serializable, CntxLoggable,
					TransfConstants {

    Noad	NULL = null;

    byte	DISPLAY_STYLE		= 0;
    byte	TEXT_STYLE		= 1;
    byte	SCRIPT_STYLE		= 2;
    byte	SCRIPT_SCRIPT_STYLE	= 3;
    byte	NUMBER_OF_STYLES	= 4;

    public interface	Provider { Noad	getNoadValue(); }

    boolean		acceptsLimits();
    boolean		isScriptable();
    boolean		isOrdinary();
    boolean		isJustChar();
    boolean		alreadySuperScripted();
    boolean		alreadySubScripted();

    void		addOnWithScripts(Log log, CntxLog cntx,
					 Field sup, Field sub);

    Noad		withLimits(byte limits);
    Field		ordinaryField();

    boolean		isNode();
    Node		getNode();

    Egg			convert(Converter conv);
    Egg			convertWithScripts(Converter conv,
					   Field sup, Field sub);
    boolean		influencesBin();
    boolean		canPrecedeBin();
    boolean		canFollowBin();

    boolean		startsWord();
    boolean		canBePartOfWord();
    boolean		finishesWord();
    MathWordBuilder	getMathWordBuilder(Converter conv, TreatNode proc);
    byte		wordFamily();
    void		contributeToWord(MathWordBuilder word);
    Egg			wordFinishingEgg(MathWordBuilder word, Converter conv);
    Egg			wordFinishingEggWithScripts(MathWordBuilder word,
						    Converter conv,
						    Field sup, Field sub);
    
}
