/* $Id: NucleusNoad.java,v 1.1.1.1 2000/10/04 21:24:07 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.Node;

public abstract class	NucleusNoad	extends ScriptableNoad {

    protected final Field		nucleus;

    public NucleusNoad(Field nucleus) { this.nucleus = nucleus; }

    protected abstract String	getDesc();
    protected abstract byte	spacingType();

    public boolean	isJustChar() { return nucleus.isJustChar(); }

    /* TeXtp[696] */
    public void		addOn(Log log, CntxLog cntx) {
	log.addEsc(getDesc());
	nucleus.addOn(log, cntx, '.');
    }

    public Egg		convert(Converter conv)
	{ return makeEgg(nucleus.convertedBy(conv)); }

    protected Egg	makeEgg(Node node)
	{ return new StItalNodeEgg(node, spacingType()); }

}
