/* $Id: StyleNoad.java,v 1.1.1.1 2000/04/07 20:51:59 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.Node;

public class	StyleNoad	extends PureNoad {

    protected final byte	style;

    public StyleNoad(byte style) { this.style = style; }

    public final boolean	influencesBin() { return false; }

    /* TeXtp[730,763] */
    public Egg		convert(Converter conv)
	{ conv.setStyle(style); return new StyleEgg(style); }

    /* TeXtp[1170,694] */
    public void		addOn(Log log, CntxLog cntx)
	{ log.addEsc(getStyleName(style)); }

    private static final String[]	styleNames
	= new String[NUMBER_OF_STYLES];

    static {
	styleNames[DISPLAY_STYLE] = "displaystyle";
	styleNames[TEXT_STYLE] = "textstyle";
	styleNames[SCRIPT_STYLE] = "scriptstyle";
	styleNames[SCRIPT_SCRIPT_STYLE] = "scriptscriptstyle";
    }

    public static String	getStyleName(byte style)
	{ return styleNames[style]; }

}
