/* $Id: SubScriptNoad.java,v 1.1.1.1 2000/10/05 07:48:43 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.MathWordBuilder;

public class	SubScriptNoad	extends ScriptNoad {

    public SubScriptNoad(Noad body, Field script) { super(body, script); }

    public final boolean	alreadySubScripted() { return true; }

    protected ScriptNoad	rebodiedCopy(Noad body)
	{ return new SubScriptNoad(body, script); }

    /* TeXtp[696] */
    public void		addOn(Log log, CntxLog cntx)
	{ body.addOnWithScripts(log, cntx, EmptyField.FIELD, script); }

    /* TeXtp[696] */
    public void		addOnWithScripts(Log log, CntxLog cntx,
					 Field sup, Field sub)
	{ body.addOnWithScripts(log, cntx, sup, script); }

    public Egg		convert(Converter conv)
	{ return body.convertWithScripts(conv, EmptyField.FIELD, script); }

    public Egg		convertWithScripts(Converter conv,
					   Field sup, Field sub)
	{ return body.convertWithScripts(conv, sup, script); }

    public Egg		wordFinishingEgg(MathWordBuilder word,
					 Converter conv) {
	return body.wordFinishingEggWithScripts(word, conv,
						EmptyField.FIELD, script);
    }

    public Egg		wordFinishingEggWithScripts(MathWordBuilder word,
						    Converter conv,
						    Field sup, Field sub)
	{ return body.wordFinishingEggWithScripts(word, conv, sup, script); }

}
