/* $Id: Transformer.java,v 1.1.1.1 2000/10/17 02:32:31 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.io.CharCode;
import	nts.node.Box;
import	nts.node.Node;
import	nts.node.NodeList;

public interface	Transformer {

    void	setStyle(byte style);
    byte	getStyle();
    boolean	isCramped();
    Dimen	muToPt(Dimen dim);
    Glue	muToPt(Glue skip);
    Dimen	scriptSpace();
    Dimen	getDimPar(int param);
    Dimen	getDimPar(int param, byte how);
    Node	fetchCharNode(byte fam, CharCode code);
    Node	fetchCharNode(byte fam, CharCode code, byte how);
    Node	fetchLargerNode(byte fam, CharCode code);
    Node	fetchSufficientNode(Delimiter del, Dimen desired);
    Box		fetchFittingWidthBox(byte fam, CharCode code, Dimen desired);
    Dimen	skewAmount(byte fam, CharCode code);
    Dimen	getXHeight(byte fam);
    NodeList	convert(NoadEnum noads);
    NodeList	convert(NoadEnum noads, byte how);

}
