/* $Id: WordPartNoad.java,v 1.1.1.1 2000/10/17 13:25:47 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.noad;

import	nts.node.Node;
import	nts.node.TreatNode;
import	nts.node.MathWordBuilder;

public abstract class	WordPartNoad	extends NucleusNoad	{

    public WordPartNoad(Field nucleus) { super(nucleus); }

    public boolean	canBePartOfWord() { return nucleus.isJustChar(); }
    public byte		wordFamily() { return nucleus.wordFamily(); }

    public MathWordBuilder	getMathWordBuilder(Converter conv,
						   TreatNode proc)
	{ return nucleus.getMathWordBuilder(conv, proc); }

    public void		contributeToWord(MathWordBuilder word)
	{ nucleus.contributeToWord(word); }

    public Egg		wordFinishingEgg(MathWordBuilder word,
					 Converter conv) {
	if (word.lastHasCollapsed()) return Egg.NULL;
	return makeEgg(word.takeLastNode());
    }

    public Egg		wordFinishingEggWithScripts(MathWordBuilder word,
						    Converter conv,
						    Field sup, Field sub) {
	Node	node = word.takeLastNode();
	Egg	egg = (word.lastHasCollapsed())
		    ? new StItalNodeEgg(node, SPACING_TYPE_ORD)
		    : makeEgg(node);
	return makeScriptsTo(egg, false, conv, sup, sub);
    }

}
