/* $Id: AnyKernNode.java,v 1.1.1.1 2000/05/26 21:20:23 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;
import	nts.io.Log;
import	nts.io.CntxLog;

public abstract class	AnyKernNode	extends DiscardableNode {
    /* root corresponding to kern_node */

    protected final Dimen		kern;

    public AnyKernNode(Dimen kern) { this.kern = kern; }

    public Dimen	getKern() { return kern; }

    public boolean	isKern() { return true; }
    public boolean	hasKern() { return true; }

    public void		addOn(Log log, CntxLog cntx)
	{ log.addEsc("kern ").add(kern.toString()); }

    public void		addBreakDescOn(Log log) { log.addEsc("kern"); }

    public boolean	isKernBreak() { return true; }
    public boolean	canBePartOfDiscretionary() { return true; }

    public int		breakPenalty(BreakingCntx brCntx)
	{ return (brCntx.spaceBreaking()) ? 0 : INF_PENALTY; }

    public NodeEnum	atBreakReplacement()
	{ return NodeList.nodes(resizedCopy(Dimen.ZERO)); }

    protected abstract AnyKernNode	resizedCopy(Dimen kern);

}
