/* $Id: AnySkipNode.java,v 1.1.1.1 2000/05/26 21:20:53 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Glue;
import	nts.io.Log;
import	nts.io.CntxLog;

public abstract class	AnySkipNode	extends DiscardableNode {
    /* root corresponding to glue_node */

    protected final Glue	skip;

    public AnySkipNode(Glue skip) { this.skip = skip; }

    public Glue		getSkip() { return skip; }

    public boolean	isSkip() { return true; }

    public void		addOn(Log log, CntxLog cntx) {
	log.addEsc("glue");
	String	name = getName();
	if (name != null)
	    log.add('(').addEsc(name).add(')');
	log.add(' ').add(skip.toString());
    }

    public FontMetric	addShortlyOn(Log log, FontMetric metric)
	{ if (!skip.isZero()) log.add(' '); return metric; }

    public String	getName() { return null; }
    public boolean	canFollowKernBreak() { return true; }
    public NodeEnum	atBreakReplacement() { return NodeList.EMPTY_ENUM; }

    public int		breakPenalty(BreakingCntx brCntx) {
	return (brCntx.spaceBreaking() && brCntx.allowedAtSkip())
	     ? 0 : INF_PENALTY;
    }

}
