/* $Id: HLeadRuleNode.java,v 1.1.1.1 2001/03/06 14:56:18 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.io.Log;
import	nts.io.CntxLog;

public class	HLeadRuleNode	extends HSkipNode {
    /* corresponding to glue_node */

    protected final BoxSizes		sizes;
    private final String		desc;

    public HLeadRuleNode(Glue skip, BoxSizes sizes, String desc)
	{ super(skip); this.sizes = sizes; this.desc = desc; }

    public BoxSizes	getSizes() { return sizes; }

    public Dimen	getHeight() { return sizes.getHeight(); }
    public Dimen	getDepth() { return sizes.getDepth(); }

    protected boolean	allegedlyVisible() { return true; }

    /* TeXtp[190] */
    public void		addOn(Log log, CntxLog cntx) {
	log.addEsc(desc).add(' ').add(skip.toString());
	cntx.addOn(log, new RuleNode(sizes));
    }

    public void		typeSet(TypeSetter setter, SettingContext sctx) {
        BoxSizes	leading
	    = new BoxSizes(sizes.rawHeight(), sctx.setting.set(skip, true),
	    		   sizes.rawDepth(), Dimen.ZERO);
	RuleNode.typeSet(setter, leading.replenished(sctx.around));
    }

    public String	toString()
	{ return "HLeadRule(" + skip + "; " + sizes + "; " + desc + ')'; }

}
