/* $Id: HLeadersNode.java,v 1.1.1.1 2001/03/06 14:57:05 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.io.Log;
import	nts.io.CntxLog;

public class	HLeadersNode	extends HSkipNode {
    /* corresponding to glue_node */

    protected final Leaders		lead;

    public HLeadersNode(Glue skip, Leaders lead)
	{ super(skip); this.lead = lead; }

    public Dimen	getHeight() { return lead.getHeight(); }
    public Dimen	getDepth() { return lead.getDepth(); }

    protected boolean	allegedlyVisible() { return true; }

    public void		addOn(Log log, CntxLog cntx)
	{ lead.addOn(log, cntx, skip); }

    public void		typeSet(TypeSetter setter, SettingContext sctx) {
	TypeSetter.Mark		here = setter.mark();
	setter.moveLeft(getLeftX(sctx.setting));
	lead.typeSet(setter, sctx.setting.set(skip, true), sctx);
	here.move();
    }

    public static final BoxLeaders.Mover	BOX_MOVER
	= new BoxLeaders.Mover() {

	public Dimen	offset(TypeSetter.Mark start)
	    { return start.xDiff(); }

	public Dimen	size(Node node)
	    { return node.getLeftX().plus(node.getWidth()); }

	public void	back(TypeSetter setter, Dimen gap)
	    { setter.moveLeft(gap); }

	public void	move(TypeSetter setter, Dimen gap)
	    { setter.moveRight(gap); }

	public void	movePrev(TypeSetter setter, Node node) {
	    setter.moveRight(node.getLeftX());
	    setter.syncVert(); setter.syncHoriz();
	}

	public void	movePast(TypeSetter setter, Node node)
	    { setter.moveRight(node.getWidth()); }

    };

    public String	toString()
	{ return "HLeaders(" + skip + "; " + lead + ')'; }

}
