/* $Id: HSkipNode.java,v 1.1.1.1 2001/03/06 14:55:56 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.io.Log;

public class	HSkipNode	extends AnySkipNode {
    /* corresponding to glue_node */

    public HSkipNode(Glue skip) { super(skip); }

    public Dimen	getWidth() { return skip.getDimen(); }
    public Dimen	getWstr() { return skip.getStretch(); }
    public byte		getWstrOrd() { return skip.getStrOrder(); }
    public Dimen	getWshr() { return skip.getShrink(); }
    public byte		getWshrOrd() { return skip.getShrOrder(); }

    public Dimen	getWidth(GlueSetting setting)
	{ return setting.set(skip, true); }

    public void		contributeVisible(VisibleSummarizer summarizer) {
	if (summarizer.setting.makesElastic(skip))
	    summarizer.claimElastic();
	super.contributeVisible(summarizer);
    }

    public boolean	startsWordBlock() { return true; }
    public byte		afterWord() { return SUCCESS; }

    public String	toString() { return "HSkip(" + skip + ')'; }

}
