/* $Id: Insertion.java,v 1.1.1.1 2000/02/19 01:43:42 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	java.io.Serializable;
import	nts.base.Num;
import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.io.Log;
import	nts.io.CntxLog;

public class	Insertion	implements Serializable {

    public static final Insertion	NULL = null;

    public final int		num;
    public final NodeList	list;
    public final Dimen		size;
    public final Glue		topSkip;
    public final Dimen		maxDepth;
    public final Num		floatCost;

    public Insertion(int num, NodeList list, Dimen size,
		     Glue topSkip, Dimen maxDepth, Num floatCost) {
	this.num = num; this.list = list; this.size = size;
	this.topSkip = topSkip; this.maxDepth = maxDepth;
	this.floatCost = floatCost;
    }

    public Insertion	makeCopy(NodeList list, Dimen size) {
	return new Insertion(num, list, size, topSkip, maxDepth, floatCost);
    }

    /* TeXtp[188] */
    public void		addOn(Log log, CntxLog cntx) {
	log.addEsc("insert").add(num)
	   .add(", natural size ").add(size.toString())
	   .add("; split(").add(topSkip.toString())
	   .add(',').add(maxDepth.toString())
	   .add("); float cost ").add(floatCost.toString());
	cntx.addOn(log, list.nodes());
    }

}
