/* $Id: LanguageNode.java,v 1.1.1.1 2000/06/06 08:26:24 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.io.Log;
import	nts.io.CntxLog;

public class	LanguageNode	extends BaseNode {
    /* root corresponding to whatsit_node */

    protected final Language		language;

    public LanguageNode(Language language) { this.language = language; }

    public boolean	sizeIgnored() { return true; }

    /* TeXtp[1356] */
    public void	addOn(Log log, CntxLog cntx)
	{ log.addEsc("setlanguage"); language.addShortlyOn(log); }

    public byte		beforeWord() { return SKIP; }
    public byte		afterWord() { return SUCCESS; }
    public Language	alteringLanguage() { return language; }

    public String	toString() { return "Language(" + language + ')'; }

}
