/* $Id: RuleNode.java,v 1.1.1.1 2000/06/06 08:28:11 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;
import	nts.io.Log;
import	nts.io.CntxLog;

public class	RuleNode	extends AnyBoxedNode {
    /* root corresponding to rule_node */

    public RuleNode(BoxSizes sizes) { super(sizes); }

    public boolean	canBePartOfDiscretionary() { return true; }
    protected boolean	allegedlyVisible() { return true; }

    public void		addOn(Log log, CntxLog cntx)
	{ log.addEsc("rule").add(sizes); }

    public FontMetric	addShortlyOn(Log log, FontMetric metric)
	{ log.add('|'); return metric; }

    public void		typeSet(TypeSetter setter, SettingContext sctx)
	{ typeSet(setter, sizes.replenished(sctx.around)); }

    public static void	typeSet(TypeSetter setter, BoxSizes s) {
        setter.moveDown(s.getDepth());
        setter.moveLeft(s.getLeftX());
	setter.setRule(s.getHeight().plus(s.getDepth()),
		       s.getWidth().plus(s.getLeftX()));
        setter.moveRight(s.getLeftX());
        setter.moveUp(s.getDepth());
    }

    public String	toString() { return "Rule(" + sizes + ')'; }

}
