/* $Id: SettingContext.java,v 1.1.1.1 1999/12/06 23:13:25 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;

public final class	SettingContext {

    public final BoxSizes		around;
    public final GlueSetting		setting;
    public final TypeSetter.Mark	start;
    public final boolean		allowIO;

    public SettingContext(BoxSizes around, GlueSetting setting,
			    TypeSetter.Mark start, boolean allowIO) {
	this.around = around; this.setting = setting;
	this.start = start; this.allowIO = allowIO;
    }

    public SettingContext	shiftedUp(Dimen shift) {
        return new SettingContext(around.shiftedUp(shift),
				  setting, start, allowIO);
    }

    public SettingContext	shiftedLeft(Dimen shift) {
        return new SettingContext(around.shiftedLeft(shift),
				  setting, start, allowIO);
    }

    public SettingContext	allowingIO(boolean allowIO)
	{ return new SettingContext(around, setting, start, allowIO); }

}
