/* $Id: SizesIterator.java,v 1.1.1.1 2000/08/09 06:05:31 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;

public abstract class	SizesIterator {

    public abstract boolean		hasMoreElements();
    public abstract void		takeNextElement();
    public abstract boolean		sizeIgnored();
    public abstract Dimen		currHeight();
    public abstract Dimen		currWidth();
    public abstract Dimen		currDepth();
    public abstract Dimen		currLeftX();
    public abstract Dimen		currStr();
    public abstract Dimen		currShr();
    public abstract byte		currStrOrd();
    public abstract byte		currShrOrd();

    /* TeXtp[668] */
    public void		summarize(SizesSummarizer pack) {
	boolean		empty = true;
	while (hasMoreElements()) {
	    takeNextElement();
	    if (!sizeIgnored()) {
		if (empty) pack.setHeight(currHeight());
		else pack.add(currHeight());
	        pack.setDepth(currDepth());
		pack.addStretch(currStr(), currStrOrd());
		pack.addShrink(currShr(), currShrOrd());
		pack.setMaxWidth(currWidth());
		pack.setMaxLeftX(currLeftX());
	    }
	    empty = false;
	}
    }

}
