/* $Id: TypeSetter.java,v 1.1.1.1 1999/12/16 17:07:29 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;
import	nts.io.CharCode;

public interface	TypeSetter {

    TypeSetter		NULL = null;

    public interface	Mark {
	void		move();
	Dimen		xDiff();
	Dimen		yDiff();
    }

    void		set(char ch, FontMetric metric);
    void		set(CharCode code, FontMetric metric);
    void		setRule(Dimen h, Dimen w);
    void		setSpecial(byte[] spec);
    void		moveLeft(Dimen x);
    void		moveRight(Dimen x);
    void		moveUp(Dimen y);
    void		moveDown(Dimen y);
    Mark		mark();
    void		syncHoriz();
    void		syncVert();
    void		push();
    void		pop();
    void		startPage(Dimen yOffset, Dimen xOffset,
    				  Dimen height, Dimen width, int[] nums);
    void		endPage();
    void		close();

}
