/* $Id: VBoxNode.java,v 1.1.1.1 2000/06/06 08:28:33 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;

public class	VBoxNode	extends AnyBoxNode {
    /* root corresponding to vlist_node */

    public VBoxNode(BoxSizes sizes, GlueSetting setting, NodeList list)
	{ super(sizes, setting, list); }

    public final boolean	isVBox() { return true; }
    public String		getDesc() { return "vbox"; }

    protected void	moveStart(TypeSetter setter)
	{ setter.moveUp(getHeight()); }

    protected void	movePrev(TypeSetter setter, Node node) {
	setter.moveDown(node.getHeight(setting));
	node.syncVertIfBox(setter);
    }

    protected void	movePast(TypeSetter setter, Node node)
	{ setter.moveDown(node.getDepth(setting)); }

    public Box		pretendSizesCopy(BoxSizes sizes)
        { return new VBoxNode(sizes, setting, list); }

    public static VBoxNode	packedOf(NodeList list, Dimen maxDepth) {
	return new VBoxNode(VertIterator.naturalSizes(list.nodes(), maxDepth),
			    GlueSetting.NATURAL, list);
    }

    public static VBoxNode	packedOf(NodeList list)
	{ return packedOf(list, Dimen.NULL); }

    //XXX could be optimized
    public static VBoxNode	packedOf(Node node)
	{ return packedOf(new NodeList(node)); }

    public String	toString()
	{ return "VBox(" + sizes + "; " + setting + "; " + list + ')'; }

}
