/* $Id: VShiftNode.java,v 1.1.1.1 2000/10/05 11:11:32 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;

public class	VShiftNode	extends AnyShiftNode {
    /* corresponding to ANY_node */

    protected VShiftNode(Node node, Dimen shift) { super(node, shift); }

    public static Node	shiftingLeft(Node node, Dimen shift) {
	return (shift.isZero()) ? node
				: new VShiftNode(node, shift.negative());
    }

    public static Node	shiftingRight(Node node, Dimen shift)
	{ return (shift.isZero()) ? node : new VShiftNode(node, shift); }

    public Dimen	getHeight() { return node.getHeight(); }
    public Dimen	getWidth() { return node.getWidth().plus(shift); }
    public Dimen	getDepth() { return node.getDepth(); }
    //XXX revide the treatment of LeftX. Where it becomes zero?
    // public Dimen	getLeftX() { return node.getLeftX().minus(shift); }
    public Dimen	getLeftX() { return Dimen.ZERO; }

    public void		typeSet(TypeSetter setter, SettingContext sctx) {
        setter.moveRight(shift);
	node.typeSet(setter, sctx.shiftedLeft(shift));
        setter.moveLeft(shift);
    }

    public Dimen	getHeight(GlueSetting setting)
	{ return node.getHeight(setting); }

    public Dimen	getWidth(GlueSetting setting)
	{ return node.getWidth(setting).plus(shift); }

    public Dimen	getDepth(GlueSetting setting)
	{ return node.getDepth(setting); }

    public Dimen	getLeftX(GlueSetting setting)
	{ return node.getLeftX(setting).minus(shift); }

    public String	toString()
	{ return "VShift(" + node + "; " + shift + ')'; }

}
