/* $Id: VertIterator.java,v 1.1.1.1 2000/08/09 06:10:07 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.node;

import	nts.base.Dimen;

public class	VertIterator	extends EnumSizesIterator {

    public VertIterator(NodeEnum nodes) { super(nodes); }

    public Dimen	currHeight() { return curr.getHeight(); }
    public Dimen	currWidth() { return curr.getWidth(); }
    public Dimen	currDepth() { return curr.getDepth(); }
    public Dimen	currLeftX() { return curr.getLeftX(); }
    public Dimen	currStr() { return curr.getHstr(); }
    public Dimen	currShr() { return curr.getHshr(); }
    public byte		currStrOrd() { return curr.getHstrOrd(); }
    public byte		currShrOrd() { return curr.getHshrOrd(); }

    public static BoxSizes	naturalSizes(NodeEnum nodes, Dimen maxDepth) {
	SizesSummarizer		pack = new SizesSummarizer();
	summarize(nodes, pack);
	if (maxDepth != Dimen.NULL) pack.restrictDepth(maxDepth);
	return new BoxSizes(pack.getHeight().plus(pack.getBody()),
			    pack.getWidth(),
			    pack.getDepth(),
			    pack.getLeftX());
    }

    public static void	summarize(NodeEnum nodes, SizesSummarizer pack)
	{ (new VertIterator(nodes)).summarize(pack); }

}
