/* $Id: TeXFmDiagnostic.java,v 1.1.1.1 1999/06/11 14:32:07 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.tfm;

/**
 * The interface which an object must implement if it is supplied for
 * reporting error messages.
 */
public interface	TeXFmDiagnostic {

    /**
     * Report a fatal error message.
     * @param	s the text of message.
     */
    void		fatal(String s);

    /**
     * Report a recoverable error message.
     * @param	s the text of message.
     */
    void		error(String s);

    /**
     * Report a warning message.
     * @param	s the text of message.
     */
    void		warning(String s);

    /**
     * Tells if the loading should be aborted also on recoverable errors
     * or on the fatals errors only.
     * @return	|true| if the loading has to be aborted on recoverable
     *		errors too.
     */
    boolean		abortOnError();

}

