/* $Id: AnyBoxPrim.java,v 1.1.1.1 2000/08/03 14:28:10 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.Box;
import	nts.node.NodeEnum;
import	nts.node.TreatBox;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.TokenList;
import	nts.command.Group;

public abstract class	AnyBoxPrim	extends BuilderPrim {

    private final TokenList.Inserter	every;

    public AnyBoxPrim(String name, TokenList.Inserter every)
	{ super(name); this.every = every; }

    public void		exec(final Builder bld, Token src) {
	makeBoxValue(new TreatBox() {
	    public boolean	wantsMig() { return bld.wantsMigrations(); }
	    public void		execute(Box box, NodeEnum mig)
		{ appendBox(bld, box, mig); }
	});
    }

    public boolean	canMakeBoxValue() { return true; }

    /* TeXtp[645] */
    public void		makeBoxValue(TreatBox proc) {
	Dimen		size = Dimen.ZERO;
	boolean		exactly = false;
	if (scanKeyword("to")) { size = scanDimen(); exactly = true; }
	else if (scanKeyword("spread")) size = scanDimen();
	pushLevel(makeGroup(size, exactly, proc));
	scanLeftBrace(); every.insertToks();
    }

    protected abstract Group	makeGroup(Dimen size, boolean exactly,
					  TreatBox proc);

}
