/* $Id: AnyUnCopyPrim.java,v 1.1.1.1 1999/08/02 17:29:36 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.node.Box;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.Prim;

public class	AnyUnCopyPrim	extends BuilderPrim {

    protected final SetBoxPrim		reg;

    public AnyUnCopyPrim(String name, SetBoxPrim reg)
	{ super(name); this.reg = reg; }

    protected Box	getBox(int idx) { return reg.get(idx); }
    protected void	finishBox(int idx) { }

    /* TeXtp[1109,1110] */
    public final Action		NORMAL = new Action() {
	public void	exec(Builder bld, Token src) {
	    int		idx = Prim.scanRegisterCode();
	    Box		box = getBox(idx);
	    if (!box.isVoid()) {
		if (bld.unBox(box)) finishBox(idx);
		else error("IncompatibleUnbox");
	    }
	}
    };

}
