/* $Id: BoxDimenPrim.java,v 1.1.1.1 1999/08/02 12:09:24 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.BoxSizes;
import	nts.node.Box;
import	nts.command.Token;
import	nts.command.AssignPrim;

public abstract class	BoxDimenPrim	extends AssignPrim
					implements Dimen.Provider {

    protected final SetBoxPrim		reg;

    public BoxDimenPrim(String name, SetBoxPrim reg)
	{ super(name); this.reg = reg; }

    /* STRANGE
     * \global\hd is allowed but has no effect
     */
    /* TeXtp[1247] */
    protected void	assign(Token src, boolean glob) {
	int		idx = scanRegisterCode();
        Box		box = reg.get(idx);
	skipOptEquals();
	Dimen		dimen = scanDimen();
	BoxSizes	sizes = box.getSizes();
	if (sizes != BoxSizes.NULL)
	    reg.foist(idx, box.pretendSizesCopy(changeSizes(sizes, dimen)));
    }

    public boolean	hasDimenValue() { return true; }

    /* TeXtp[420] */
    public Dimen	getDimenValue() {
	BoxSizes	sizes = reg.get(scanRegisterCode()).getSizes();
	return (sizes != BoxSizes.NULL) ? selectSize(sizes) : Dimen.ZERO;
    }

    protected abstract BoxSizes	changeSizes(BoxSizes sizes, Dimen dimen);
    protected abstract Dimen	selectSize(BoxSizes sizes);

}
