/* $Id: BuilderPrim.java,v 1.1.1.1 2000/04/18 21:38:46 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.io.Log;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.CtrlSeqToken;
import	nts.command.TokenList;
import	nts.command.Command;
import	nts.command.Primitive;

public abstract class	BuilderPrim	extends BuilderCommand
					implements Primitive {

    /** The name of the primitive */
    private String		name;

    protected	BuilderPrim(String name) { this.name = name; }

    public final String		getName() { return name; }

    public final Command	getCommand() { return this; }

    public final void		addOn(Log log) { log.addEsc(name); }

    public final String		toString() { return "@" + name; }

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     *
     */

    public static final int	INTP_MAX_MARK_WIDTH = newIntParam();

    public static void		addNodeToks(Log log, TokenList list) {
	log.add('{');
	list.addOn(log, getConfig().getIntParam(INTP_MAX_MARK_WIDTH));
	log.add('}');
    }

    private static final Token	PAR_TOKEN = new CtrlSeqToken("par");

    /* TeXtp[1090] */
    public static final Action	START_PAR = new Action() {
        public void	exec(Builder bld, Token src)
	    { backToken(src); Paragraph.start(true); }
    };

    /* TeXtp[1094,1095] */
    public static final Action	FINISH_PAR = new Action() {
        public void	exec(Builder bld, Token src)
	    { backToken(src); insertToken(PAR_TOKEN); }
    };

    /* TeXtp[1094,1095] */
    public static final Action	REJECT = new Action() {
        public void	exec(Builder bld, Token src)
	    { getGrp().reject(src); }
    };

    public static final Action	EMPTY = new Action() {
        public void	exec(Builder bld, Token src) { }
    };

}
