/* $Id: EndPrim.java,v 1.1.1.1 2000/01/28 15:57:33 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Num;
import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.node.BoxSizes;
import	nts.node.GlueSetting;
import	nts.node.NodeList;
import	nts.node.HBoxNode;
import	nts.node.VSkipNode;
import	nts.node.PenaltyNode;
import	nts.builder.Builder;
import	nts.command.Token;

public class	EndPrim	extends BuilderPrim {

    private boolean		dumping;

    public EndPrim(String name, boolean dumping)
	{ super(name); this.dumping = dumping; }

    public static final int	DIMP_HSIZE = newDimParam();

    /* TeXtp[1054] */
    public final Action		NORMAL = new Action() {

	public void	exec(Builder bld, Token src) {
	    if (bld.isEmpty() && !getTypoConfig().pendingOutput())
		endMainLoop(dumping);
	    else {
		backToken(src);
		bld.addBox(new HBoxNode(
		    new BoxSizes(Dimen.ZERO,
				 getConfig().getDimParam(DIMP_HSIZE),
				 Dimen.ZERO, Dimen.ZERO),
		    GlueSetting.NATURAL, NodeList.EMPTY));
		bld.addNode(new VSkipNode(
		    Glue.valueOf(Dimen.ZERO, Dimen.UNITY, Glue.FILL,
		    		 Dimen.ZERO, Glue.NORMAL)));
		bld.addNode(new PenaltyNode(Num.valueOf(-0x40000000)));
		bld.buildPage();
	     }
	}

    };

}
