/* $Id: FontDimenPrim.java,v 1.1.1.1 1999/08/27 15:33:51 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.FontMetric;
import	nts.command.Token;

public class	FontDimenPrim	extends TypoAssignPrim
				implements Dimen.Provider {

    public FontDimenPrim(String name) { super(name); }

    /* STRANGE
     * \global\fontdimen is allowed but has no effect
     */
    /* TeXtp[1253,578] */
    protected void		assign(Token src, boolean glob) {
        int		num = scanInt();
        FontMetric	metric = scanFontMetric();
	FontDimen	fDim = getTypoHandler().getFontDimen(metric, num);
	skipOptEquals(); fDim.set(scanDimen());
    }

    public boolean	hasDimenValue() { return true; }

    /* TeXtp[425,578] */
    public Dimen	getDimenValue() {
        int		num = scanInt();
        FontMetric	metric = scanFontMetric();
	return getTypoHandler().getFontDimen(metric, num).get();
    }

}
