/* $Id: HyphenPrim.java,v 1.1.1.1 2000/04/30 19:14:12 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Num;
import	nts.io.CharCode;
import	nts.node.Node;
import	nts.node.NodeList;
import	nts.node.DiscretionaryNode;
import	nts.node.FontMetric;
import	nts.builder.Builder;
import	nts.command.Token;

public class	HyphenPrim	extends BuilderPrim {

    public	HyphenPrim(String name) { super(name); }

    /* TeXtp[1117] */
    public final Action		NORMAL = new Action() {
	public void	exec(final Builder bld, Token src) {
	    NodeList	pre = NodeList.EMPTY;
	    FontMetric	metric = getCurrFontMetric();
	    Num		num
		= metric.getNumParam(FontMetric.NUM_PARAM_HYPHEN_CHAR);
	    if (num != Num.NULL) {
		CharCode	code = Token.makeCharCode(num.intVal());
		if (code != CharCode.NULL) {
		    Node	node = metric.getCharNode(code);
		    if (node != Node.NULL) pre = new NodeList(node);
		    else charWarning(metric, code);
		}
	    }
	    bld.addNode(new DiscretionaryNode(
				pre, NodeList.EMPTY, NodeList.EMPTY));
	}
    };

}
