/* $Id: HyphenationPrim.java,v 1.1.1.1 2000/06/12 21:39:52 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	java.util.Vector;
import	nts.io.CharCode;
import	nts.io.Name;
import	nts.command.Token;
import	nts.command.Command;

public class	HyphenationPrim	extends TypoAssignPrim {

    public HyphenationPrim(String name) { super(name); }

    /* STRANGE
     * \global\hyphenation is allowed but has no effect
     * STRANGE
     * in one error message \hyphenation is passed in other it is literal
     */
    /* TeXtp[934] */
    protected void	assign(Token src, boolean glob) {
	scanLeftBrace();
	StringBuffer	buf = new StringBuffer();
	Vector		hyphBuf = new Vector();
	int		index = 0;
	for (;;) {
	    Token	tok = nextExpToken();
	    Command	cmd = meaningOf(tok);
	    CharCode	code = cmd.charCodeToAdd();
	    if (code != CharCode.NULL) {
		if (code.match('-')) hyphBuf.add(new Integer(index));
		else {
		    char	letter = code.toCanonicalLetter();
		    if (letter != CharCode.NO_CHAR)
			{ buf.append(letter); index++; }
		    else error("NonLetterInHyph");
		}
	    } else if (cmd.isSpacer() || cmd.isRightBrace()) {
		if (index > 1) {
		    int[]	positions = new int[hyphBuf.size()];
		    for (int i = 0; i < positions.length; i++)
			positions[i] = ((Integer) hyphBuf.get(i)).intValue();
		    getTypoConfig().getLanguage()
				.setHyphException(buf.toString(), positions);
		    index = 0; buf.setLength(0); hyphBuf.clear();
		}
		if (cmd.isRightBrace()) break;
	    } else error("ImproperHyphen", this);
	}
    }

}
