/* $Id: InsertPrim.java,v 1.1.1.1 2000/06/22 18:38:45 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Num;
import	nts.base.Dimen;
import	nts.base.Glue;
import	nts.node.NodeList;
import	nts.node.VBoxNode;
import	nts.node.Insertion;
import	nts.node.InsertNode;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.Prim;

public class	InsertPrim	extends BuilderPrim {

    public InsertPrim(String name) { super(name); }

    /* TeXtp[1099] */
    public void		exec(Builder bld, Token src) {
	int	num = Prim.scanRegisterCode();
	int	outBoxNum = getConfig().getIntParam(INTP_OUTPUT_BOX_NUM);
	if (num == outBoxNum) {
	    num = 0;
	    error("CantInsertOutbox", InsertPrim.this,
		    num(outBoxNum), num(num));
	}
	pushLevel(new InsertGroup(num)); scanLeftBrace();
    }

    public static final int	INTP_FLOATING_PENALTY = newIntParam();

    /* TeXtp[1100] */
    public static class	InsertGroup	extends VertGroup {

	private int		num;

	protected InsertGroup(int num) { this.num = num; }

	private Glue		topSkip;
	private Dimen		maxDepth;
	private int		floatCost;

	public void		stop() {
	    super.stop();
	    topSkip = getConfig().getGlueParam(GLUEP_SPLIT_TOP_SKIP);
	    maxDepth = getConfig().getDimParam(DIMP_SPLIT_MAX_DEPTH);
	    floatCost = getConfig().getIntParam(INTP_FLOATING_PENALTY);
	}

	public void		close() {
	    super.close();
	    NodeList	list = builder.getList();
	    VBoxNode	vbox = VBoxNode.packedOf(list);
	    Dimen	size = vbox.getHeight().plus(vbox.getDepth());
	    Builder	bld = getBld();
	    bld.addNode(new InsertNode(
		    new Insertion(num, list, size, topSkip,
				  maxDepth, Num.valueOf(floatCost))));
	    bld.buildPage();
	}
    }

}
