/* $Id: LastBoxPrim.java,v 1.1.1.1 2000/02/15 09:54:43 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.node.Node;
import	nts.node.Box;
import	nts.node.VoidBoxNode;
import	nts.builder.Builder;

public class	LastBoxPrim	extends FetchBoxPrim {

    public LastBoxPrim(String name) { super(name); }

    /* TeXtp[1080] */
    public Box		getBoxValue() {
        Builder		bld = getBld();
	if (bld.canTakeLastBox()) {
	    Node		node = bld.lastNode();
	    if (node != Node.NULL && node.isBox()) {
		bld.removeLastNode();
		return node.getBox();
	    }
	} else if (bld.canTakeLastNode())
	    error("LastBoxIn", this, bld);
	else error("CantTakeFromPage", this, bld);
	return VoidBoxNode.BOX;
    }

}
