/* $Id: MarkPrim.java,v 1.1.1.1 2000/05/26 21:25:01 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.MigratingNode;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.TokenList;
import	nts.command.Prim;

public class	MarkPrim	extends BuilderPrim {

    public	MarkPrim(String name) { super(name); }

    /* TeXtp[1101] */
    public void		exec(Builder bld, Token src)
	{ bld.addNode(new MarkNode(Prim.scanTokenList(src, true))); }

    protected static class	MarkNode	extends MigratingNode {
	/* root corresponding to mark_node */

	protected TokenList		list;

	public MarkNode(TokenList list) { this.list = list; }

	public boolean		isMark() { return true; }

	public TokenList	getMark() { return list; }

	/* TeXtp[196] */
	public void		addOn(Log log, CntxLog cntx)
	    { addNodeToks(log.addEsc("mark"), list); }

    }

}
