/* $Id: OpenOutPrim.java,v 1.1.1.1 2000/05/26 21:14:44 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.TypeSetter;
import	nts.node.SettingContext;
import	nts.builder.Builder;
import	nts.command.FileName;
import	nts.command.Token;
import	nts.command.Prim;

public class	OpenOutPrim	extends BuilderPrim {

    private WritePrim		write;

    public OpenOutPrim(String name, WritePrim write)
	{ super(name); this.write = write; }

    private void	open(int num, FileName name)
	{ write.set(num, getIOHandler().openWrite(name, num)); }

    public void		exec(Builder bld, Token src) {
        int		num = Prim.scanFileCode();
	skipOptEquals();
	FileName	name = scanFileName();
	bld.addNode(new OpenOutNode(num, name));
    }

    /* TeXtp[1351] */
    public boolean		immedExec(Token src) {
        int		num = Prim.scanFileCode();
	skipOptEquals();
	FileName	name = scanFileName();
	open(num, name);
	return true;
    }

    protected class	OpenOutNode	extends WritePrim.FileNode {
	/* corresponding to whatsit_node */

	protected FileName		name;

	public OpenOutNode(int num, FileName name)
	    { super(num); this.name = name; }

	/* TeXtp[1356] */
	public void	addOn(Log log, CntxLog cntx)
	    { addName(log, "openout").add('=').add(name); }

	/* TeXtp[1366, 1367] */
	public void	typeSet(TypeSetter setter, SettingContext sctx)
	    { if (sctx.allowIO) open(num, name); }

    }

}
