/* $Id: PageDimenPrim.java,v 1.1.1.1 2000/01/13 16:00:09 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.PageSplit;
import	nts.command.Token;
import	nts.command.AssignPrim;

public abstract class	PageDimenPrim	extends AssignPrim
					implements Dimen.Provider {

    protected PageSplit		page;

    public PageDimenPrim(String name, PageSplit page)
	{ super(name); this.page = page; }

    /* STRANGE
     * \global\pagegoal is allowed but has no effect
     */
    /* TeXtp[1245] */
    protected void		assign(Token src, boolean glob) {
	skipOptEquals();
	Dimen		dim = scanDimen();
	if (page.canChangeDimens()) set(dim);
    }

    /* TeXtp[421] */
    public boolean		hasDimenValue() { return true; }
    public final Dimen		getDimenValue() { return get(); }

    protected abstract Dimen	get();
    protected abstract void	set(Dimen dim);

}
