/* $Id: PageNumPrim.java,v 1.1.1.1 2000/01/03 14:03:43 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.IntProvider;
import	nts.base.Num;
import	nts.command.Token;
import	nts.command.AssignPrim;

public abstract class	PageNumPrim	extends AssignPrim
					implements IntProvider, Num.Provider {

    protected Page.List		page;

    public PageNumPrim(String name, Page.List page)
	{ super(name); this.page = page; }

    /* STRANGE
     * \global\pagegoal is allowed but has no effect
     */
    /* TeXtp[1246] */
    protected void		assign(Token src, boolean glob) {
	skipOptEquals();
	int		num = scanInt();
	if (page.canChangeNums()) set(num);
    }

    /* TeXtp[421] */
    public boolean		hasNumValue() { return true; }
    public final Num		getNumValue() { return Num.valueOf(get()); }
    public final int		intVal() { return get(); }

    protected abstract int	get();
    protected abstract void	set(int num);

}
