/* $Id: PrevGrafPrim.java,v 1.1.1.1 2000/02/07 11:56:33 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Num;
import	nts.builder.Builder;
import	nts.command.Token;

public class	PrevGrafPrim	extends TypoAssignPrim
				implements Num.Provider {

    public PrevGrafPrim(String name) { super(name); }

    /* STRANGE
     * \global\prevgraf is allowed but has no effect
     */
    /* TeXtp[1244] */
    protected void	assign(Token src, boolean glob) {
	skipOptEquals();
	int		pg = scanInt();
	if (pg < 0) error("BadPrevGraf", this, num(pg));
	else getBld().setPrevGraf(pg);
    }

    public boolean	hasNumValue() { return true; }

    /* TeXtp[422] */
    public Num		getNumValue()
	{ return Num.valueOf(getBld().getPrevGraf()); }

}
