/* $Id: RulePrim.java,v 1.1.1.1 1999/09/06 05:43:08 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.BoxSizes;
import	nts.builder.Builder;
import	nts.command.Token;

public class	RulePrim	extends BuilderPrim {

    private final Dimen		defaultHeight;
    private final Dimen		defaultWidth;
    private final Dimen		defaultDepth;
    private final Dimen		defaultLeftX;

    public RulePrim(String name) {
	super(name);
	defaultHeight = Dimen.NULL; defaultWidth = Dimen.NULL;
	defaultDepth = Dimen.NULL; defaultLeftX = Dimen.NULL;
    }

    public RulePrim(String name, Dimen h, Dimen w, Dimen d, Dimen l) {
	super(name);
	defaultHeight = h; defaultWidth = w;
	defaultDepth = d; defaultLeftX = l;
    }

    /* TeXtp[1056] */
    public final Action		NORMAL = new Action() {
	public void	exec(Builder bld, Token src)
	    { bld.addRule(getRule()); }
    };

    /* TeXtp[1094,1095] */
    public final Action		BAD_HRULE = new Action() {
        public void	exec(Builder bld, Token src)
	    { error("CantUseHrule", RulePrim.this); }
    };


    public boolean	hasRuleValue() { return true; }
    public BoxSizes	getRuleValue() { return getRule(); }

    public BoxSizes	getRule() {
	return scanRule(defaultHeight, defaultWidth,
			defaultDepth, defaultLeftX);
    }

    /* TeXtp[463] */
    public static BoxSizes	scanRule(Dimen h, Dimen w, Dimen d, Dimen l) {
	for (;;) if (scanKeyword("width")) w = scanDimen();
	    else if (scanKeyword("height")) h = scanDimen();
	    else if (scanKeyword("depth")) d = scanDimen();
	    else break;
	return new BoxSizes(h, w, d, l);
    }

}
