/* $Id: SpecialPrim.java,v 1.1.1.1 2000/05/27 02:14:03 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.io.Log;
import	nts.io.CntxLog;
import	nts.node.BaseNode;
import	nts.node.TypeSetter;
import	nts.node.SettingContext;
import	nts.builder.Builder;
import	nts.command.Token;
import	nts.command.TokenList;
import	nts.command.Prim;

public class	SpecialPrim extends BuilderPrim {

    public SpecialPrim(String name) { super(name); }

    /* TeXtp[1354] */
    public void		exec(Builder bld, Token src)
	{ bld.addNode(new SpecialNode(Prim.scanTokenList(src, true))); }

    protected class	SpecialNode	extends BaseNode {
	/* root corresponding to whatsit_node */

	protected TokenList		list;

	public SpecialNode(TokenList list) { this.list = list; }

	public boolean	sizeIgnored() { return true; }

	/* TeXtp[1356] */
	public void	addOn(Log log, CntxLog cntx)
	    { addNodeToks(log.addEsc("special"), list); }

	/* TeXtp[1368] */
	public void	typeSet(TypeSetter setter, SettingContext sctx) {
	    Log		log = getIOHandler().makeStringLog();
	    log.add(list); setter.setSpecial(log.toString().getBytes());
	    //XXX getBytes() is not proper
	}

	public byte	beforeWord() { return SKIP; }
	public byte	afterWord() { return SUCCESS; }

    }

}
