/* $Id: TypoAssignPrim.java,v 1.2 2001/09/09 22:17:59 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.command.Token;
import	nts.command.PrefixPrim;

public abstract class	TypoAssignPrim	extends TypoPrim {

    protected	TypoAssignPrim(String name) { super(name); }

    /** Non prefixed version of exec */
    public final void		exec(Token src) { exec(src, 0); }

    public final boolean	assignable() { return true; }
    public void			doAssignment(Token src, int prefixes)
				    { exec(src, prefixes); }

    /**
     * Performs itself in the process of interpretation of the macro language
     * after sequence of prefix commands.
     * @param	src source token for diagnostic output.
     * @param	prefixes accumulated code of prefixes.
     */
    public final void		exec(Token src, int prefixes) {
	PrefixPrim.beforeAssignment(this, prefixes);
	assign(src, PrefixPrim.globalAssignment(prefixes));
	PrefixPrim.afterAssignment();
    }

    /**
     * Performs the assignment.
     * @param	src source token for diagnostic output.
     * @param	glob indication that the assignment is global.
     */
    protected abstract void	assign(Token src, boolean glob);

}
