/* $Id: VBoxGroup.java,v 1.1.1.1 2001/04/27 16:02:16 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.Box;
import	nts.node.TreatBox;
import	nts.node.NodeList;

public class	VBoxGroup	extends VertGroup {

    protected Dimen		size;
    protected boolean		exactly;
    protected TreatBox		proc;

    public VBoxGroup(Dimen size, boolean exactly, TreatBox proc)
	{ this.size = size; this.exactly = exactly; this.proc = proc; }

    protected Dimen		maxDepth;

    public void		stop() {
	super.stop();
	maxDepth = getConfig().getDimParam(TypoCommand.DIMP_BOX_MAX_DEPTH);
    }

    public void		close() {
        super.close();
	proc.execute(makeBox(builder.getList()), NodeList.EMPTY_ENUM);
    }

    protected Box	makeBox(NodeList list)
	{ return TypoCommand.packVBox(list, size, exactly, maxDepth); }

}
