/* $Id: VTopGroup.java,v 1.1.1.1 2001/04/27 16:04:14 ksk Exp $
 *
 * NTS: The New Typesetting System (modular reimplementation of TeX)
 * Copyright (C) 2001  Karel Skoupy
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * email: ksk@dante.de
 * snail: Karel Skoupy
 *        c/o DANTE, Deutschsprachige Anwendervereinigung TeX e.V.
 *        Postfach 10 18 40, 69008 Heidelberg, Germany
 * www:   http://www.dante.de
 */
package	nts.typo;

import	nts.base.Dimen;
import	nts.node.BoxSizes;
import	nts.node.GlueSetting;
import	nts.node.Box;
import	nts.node.TreatBox;
import	nts.node.NodeList;
import	nts.node.SizesEvaluator;
import	nts.node.VertIterator;
import	nts.node.VBoxNode;

public class	VTopGroup	extends VBoxGroup {

    public VTopGroup(Dimen size, boolean exactly, TreatBox proc)
	{  super(size, exactly, proc); }

    public static final VTopPacker	packer = new VTopPacker();

    protected Box	makeBox(NodeList list)
	{ return packer.packVTop(list, size, exactly, maxDepth); }

    public static class	VTopPacker	extends TypoCommand.VBoxPacker {

	/* STRANGE
	 * two vboxes are created: vtop as a final result and vbox solely for
	 * diagnostic messages because TeX displays vbox when reporting bad
	 * vbox and only after that moves the reference point to make vtop
	 * from the vbox.
	 */
	/* TeXtp[1087] */
	public VBoxNode		packVTop(NodeList list, Dimen desired,
					boolean exactly, Dimen maxDepth) {
	    SizesEvaluator	pack = new SizesEvaluator();
	    VertIterator.summarize(list.nodes(), pack);
	    if (maxDepth != Dimen.NULL) pack.restrictDepth(maxDepth);
	    Dimen	size = pack.getBody().plus(pack.getHeight());
	    boolean	empty = list.isEmpty();
	    if (exactly)
		{ pack.evaluate(desired.minus(size), empty); size = desired; }
	    else { pack.evaluate(desired, empty); size = size.plus(desired); }
	    BoxSizes	sizes
		= new BoxSizes(size, pack.getWidth(),
			       pack.getDepth(), pack.getLeftX());
	    VBoxNode	vbox =  new VBoxNode(sizes, pack.getSetting(), list);
	    if (check(pack)) reportBox(vbox);
	    Dimen	height = pack.getHeight();
	    //XXX misusing of instanceof and not correct (discretionary)
	    if (!(  list.isEmpty()
		 || list.nodeAt(0) instanceof nts.node.AnyBoxedNode  ))
		height = Dimen.ZERO;
	    sizes = new BoxSizes(height, pack.getWidth(),
				 size.minus(height).plus(pack.getDepth()),
				 pack.getLeftX());
	    VBoxNode	vtop =  new VBoxNode(sizes, pack.getSetting(), list);
	    return vtop;
	}

    }

}
